//
//EV_MarioBlock translated into Lua because stupidity
//Only one block can move at a time, I'm not making a table
//

local block = nil
local blocktop = 0
local blockbottom = 0
local blocktimer = 0

local DISTANCE = 4
local FACTOR = 4

addHook("NetVars", function(network)
	block = network($)
	blocktop = network($)
	blockbottom = network($)
	blocktimer = network($)
end)

local DoDumbBlock = function(sector)
	if not (sector and sector.valid) or block == sector then return end
	
	if block and block.valid
		block.floorheight = blocktop
		block.ceilingheight = blockbottom
	end
	
	block = sector
	blocktop = block.floorheight
	blockbottom = block.ceilingheight
	blocktimer = 1
end

addHook("ThinkFrame", do
	if block and block.valid and blocktimer
		local dist = blocktimer
		if blocktimer > DISTANCE
			dist = DISTANCE*2 - blocktimer
		end
		
		block.floorheight = blocktop - dist*FRACUNIT*FACTOR
		block.ceilingheight = blockbottom - dist*FRACUNIT*FACTOR
		blocktimer = $ + 1
		
		if blocktimer > DISTANCE*2	
			block.floorheight = blocktop
			block.ceilingheight = blockbottom
			block = nil
			blocktimer = 0
		end
	end
end)

rawset(_G, "MarioGroundPoundBlock", function(mo, fof)
	local sector = fof.sector
	local spring = false
	local thing
	
	if block == sector then return end
	if mo.eflags & MFE_VERTICALFLIP then return end
	if not (sector and sector.valid) return end
	
	for mobj in sector.thinglist()
		if mobj.flags & (MF_NOCLIP|MF_NOTHINK|MF_SCENERY)
			continue
		end
		
		if mobj.flags & MF_SPRING
			spring = true
			continue
		end
		
		if mobj.health == 0 // this only really applies for monitors
		or (not (mobj.flags & MF_MONITOR) and (mobj.info.flags & MF_MONITOR)) // gold monitor support
			continue
		end
		
		thing = mobj
		break
	end
	
	if thing and thing.valid
		local oldx = thing.x
		local oldy = thing.y
		local oldz = thing.z
		local oldflags = thing.flags
		local height = mo.player and P_GetPlayerHeight(mo.player) or mo.height
		
		thing.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
		P_TeleportMove(thing, mo.x, mo.y, sector.ceilingheight - height)
		thing.momz = 0
		
		if thing.flags & MF_SHOOTABLE
			if thing.flags & MF_MONITOR
				thing.z = $ - 13*thing.scale
			end
			
			P_DamageMobj(thing, mo, mo, 1, 0)
		elseif thing.type == MT_RING or thing.type == MT_COIN or thing.type == MT_TOKEN
			thing.z = mo.z
			thing.flags = oldflags
			P_CheckPosition(thing, thing.x, thing.y, thing.z)
			thing.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
			thing.z = sector.ceilingheight - height
			thing.momz = -6*thing.scale
		else
			// "Powerup rise" sound
			S_StartSound(mo, sfx_mario9) // Puncher is "close enough"
			thing.flags = oldflags
		end

		if thing.flags & MF_MONITOR
			P_TeleportMove(thing, oldx, oldy, oldz)
			thing.momx = 1
			thing.momy = 1
		end
		
		DoDumbBlock(sector)
		
		return true
	elseif spring
		S_StartSound(mo, sfx_mario1)
	end
end)