//
//P_ButteredSlope translated into Lua because stupidity
//

rawset(_G, "MarioButteredSlope", function(mo, reversed)
	local thrust
	
	if (not mo.standingslope)
		return
	end

	if (mo.standingslope.flags & SL_NOPHYSICS)
		return // No physics, no butter.
	end

	if (mo.flags & (MF_NOCLIPHEIGHT|MF_NOGRAVITY))
		return // don't slide down slopes if you can't touch them or you're not affected by gravity
	end

	if (mo.player)
		if (abs(mo.standingslope.zdelta) < FRACUNIT/4 and not (mo.player.pflags & PF_SPINNING))
			return // Don't slide on non-steep slopes unless spinning
		end

		if (abs(mo.standingslope.zdelta) < FRACUNIT/2 and not (mo.player.rmomx or mo.player.rmomy))
			return // Allow the player to stand still on slopes below a certain steepness
		end
	end

	thrust = sin(mo.standingslope.zangle) * 3 / 2 * (mo.eflags & MFE_VERTICALFLIP and 1 or -1)

	if (mo.player and (mo.player.pflags & PF_SPINNING))
		local mult = 0
		if (mo.momx or mo.momy)
			local angle = R_PointToAngle2(0, 0, mo.momx, mo.momy) - mo.standingslope.xydirection

			if (P_MobjFlip(mo) * mo.standingslope.zdelta < 0)
				angle = $ ^ ANGLE_180
			end

			mult = cos(angle)
		end

		thrust = FixedMul(thrust, FRACUNIT*2/3 + mult/8)
	end

	if (mo.momx or mo.momy) // Slightly increase thrust based on the object's speed
		thrust = FixedMul(thrust, FRACUNIT+P_AproxDistance(mo.momx, mo.momy)/16)
	end
	// This makes it harder to zigzag up steep slopes, as well as allows greater top speed when rolling down

	// Let's get the gravity strength for the object...
	thrust = FixedMul(thrust, abs(P_GetMobjGravity(mo)))

	// ... and its friction against the ground for good measure (divided by original friction to keep behaviour for normal slopes the same).
	thrust = FixedMul(thrust, FixedDiv(mo.friction, 29*FRACUNIT/32))

	if reversed
		P_Thrust(mo, mo.standingslope.xydirection + ANGLE_180, thrust)
	else
		P_Thrust(mo, mo.standingslope.xydirection, thrust)
	end
end)