//
//Super Luigi's bot behavior
//

local SPINSTATE = S_MARIO_SPIN
local STARTUPTIME = TICRATE/3
local ABILITYTIME = TICRATE*4

addHook("BotTiccmd", function(bot, cmd)
	local player = bot.botleader
	local mo = player and player.mo
	local mobj = bot.mo
	if not (IsMario(mo) and IsMario(mobj)) then return end
	
	//Indicator
	local helper = false
	if mobj.luigiindicator and mobj.luigiindicator.valid
		if not player.speed and P_IsObjectOnGround(mobj)
		and P_AproxDistance((mobj.z + mobj.height/2) - (mo.z + mobj.height/2),
		P_AproxDistance(mobj.x - mo.x, mobj.y - mo.y)) <= mobj.radius*2
			mobj.luigiindicator.flags2 = $ &~ MF2_DONTDRAW
			helper = true
		else
			mobj.luigiindicator.flags2 = $ | MF2_DONTDRAW
		end
	else
		mobj.luigiindicator = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_OVERLAY)
		mobj.luigiindicator.target = mobj
		mobj.luigiindicator.state = S_FLIGHTINDICATOR
		mobj.luigiindicator.flags2 = $ | MF2_DONTDRAW
	end
	
	//During ability
	if mobj.luigiability
		if P_IsObjectOnGround(mo) or -mobj.luigiability >= ABILITYTIME
		or (mobj.luigiability < 0
		and (bot.powers[pw_carry] != CR_PLAYER or not player.mariospinjump))
			if player.mariospinjump
				mo.momx = $/2
				mo.momy = $/2
				mo.state = S_PLAY_FALL
			end
			player.pflags = $ &~ PF_CANCARRY
			
			mobj.momx = $/2
			mobj.momy = $/2
			
			P_ResetPlayer(bot)
			mobj.state = S_PLAY_FALL
			mobj.luigiability = 0
			
		elseif mobj.luigiability > 0
			player.pflags = $ | PF_FULLSTASIS
			
			mobj.luigiability = $ + 1
			if mobj.luigiability >= STARTUPTIME
				mo.momz = 0
				mobj.luigiability = -1
				
				player.mariospinjump = 1
				player.mariospinsfx = -22
				mo.state = SPINSTATE
				
				player.glidetime = 0
				S_StartSound(mo, sfx_mrspun)
				MarioPlayVoice(player, "spinjump")
				
				mobj.tracer = mo
				bot.powers[pw_carry] = CR_PLAYER
				player.pflags = $ | PF_CANCARRY
				S_StartSound(mobj, sfx_s3k4a)
			end
			
		else
			mobj.luigiability = $ - 1
			mo.momz = 0
			
			local angle = player.marioinputangle
			if not player.cmd.forwardmove and not player.cmd.sidemove
			and mobj.luigiability < -2
				angle = R_PointToAngle2(0,0,mobj.momx,mobj.momy)
			end
			P_InstaThrust(mo, angle, FixedMul(player.normalspeed, mo.scale))
			
			player.pflags = $ | PF_CANCARRY
			if not (mobj.luigiability % 3)
				P_SpawnGhostMobj(mo)
				P_SpawnGhostMobj(mobj)
			end
		end
		bot.pflags = $ | PF_STASIS
		
		return true
		
	//Start ability
	elseif helper and player.pflags & PF_JUMPED and player.cmd.buttons & BT_JUMP
	and player.pflags & PF_STARTJUMP and mo.momz*P_MobjFlip(mo) > 0
		mobj.luigiability = 1
		P_SetObjectMomZ(mo, 24*FRACUNIT, false)
		P_SetObjectMomZ(mobj, 16*FRACUNIT, false)
		
		player.pflags = $ | PF_FULLSTASIS
		player.glidetime = -1
		
		bot.pflags = $ | PF_FULLSTASIS
		bot.glidetime = -1
		
		mo.state = S_PLAY_TWINSPIN
		mobj.state = S_PLAY_TWINSPIN
		
		MarioPlayVoice(bot, "spinjump")
		return true
	end
end)