//
//The Lua for Mario's commands
//

//String to button
local buttonconv = {
	["weaponnext"] = BT_WEAPONNEXT,
	["nextweapon"] = BT_WEAPONNEXT,
	["weaponprev"] = BT_WEAPONPREV,
	["prevweapon"] = BT_WEAPONPREV,
	["fire"] = BT_ATTACK,
	["spin"] = BT_SPIN,
	["tossflag"] = BT_TOSSFLAG,
	["firenormal"] = BT_FIRENORMAL,
	["custom1"] = BT_CUSTOM1,
	["custom2"] = BT_CUSTOM2,
	["custom3"] = BT_CUSTOM3,
}

//Button to string
local buttonconv2 = {
	[BT_WEAPONNEXT] = "weaponnext",
	[BT_WEAPONPREV] = "weaponprev",
	[BT_ATTACK] = "fire",
	[BT_SPIN] = "spin",
	[BT_TOSSFLAG] = "tossflag",
	[BT_FIRENORMAL] = "firenormal",
	[BT_CUSTOM1] = "custom1",
	[BT_CUSTOM2] = "custom2",
	[BT_CUSTOM3] = "custom3",
}

//
//Local commands
//

//mariovoice command
local default = "On"
local file = io.openlocal("client/Mario/Voice.dat")
if file
	local num = file:read("*n")
	if num == 0
		default = "Off"
	end
	file:close()
end
rawset(_G, "mariovoice", CV_RegisterVar({
	name = "mariovoice",
	defaultvalue = default,
	flags = CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(cv)
		if io
			local file = io.openlocal("client/Mario/Voice.dat", "w+")
			file:write(cv.value)
			file:close()
		end
	end
}))

//mariodeathjingle command
local default = "On"
local file = io.openlocal("client/Mario/DeathJingle.dat")
if file
	local num = file:read("*n")
	if num == 0
		default = "Off"
	end
	file:close()
end
rawset(_G, "mariodeathjingle", CV_RegisterVar({
	name = "mariodeathjingle",
	defaultvalue = default,
	flags = CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(cv)
		if io
			local file = io.openlocal("client/Mario/DeathJingle.dat", "w+")
			file:write(cv.value)
			file:close()
		end
	end
}))

//
//Netgame commands
//

//mariompcoins
rawset(_G, "mariocoins", CV_RegisterVar({
	name = "mariocoins",
	defaultvalue = 0,
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(cv)
		if cv.value
			print("Coins will now always be replaced with rings.")
		else
			print("Coins will no longer be replaced with rings for anyone other than Mario in single player.")
		end
	end
}))

//mariopowerup - This command is a complete hack but it works
rawset(_G, "mariopowerup", CV_RegisterVar({
	name = "mariopowerup",
	defaultvalue = 1,
	flags = CV_NETVAR|CV_CALL,
	PossibleValue = CV_OnOff,
	func = function(cv)
		if not SH_FAKEBALL
			return
			
		elseif srb2p
			print("Mario cannot use his powerups in SRB2 Persona.")
			return
			
		elseif cv.value
			print("Mario can now receive his powerups.")
			
			SH_FAKEBALL = SH_PITY
			SH_SUPERBALL = SH_PINK
			SH_CAPE = SH_WHIRLWIND
			SH_BALLOON = SH_ARMAGEDDON
			SH_FAKEMETAL = SH_ELEMENTAL
			SH_FAKEMINI = SH_ATTRACT
			SH_SHOE = SH_FLAMEAURA
			SH_ICEFLOWER = SH_BUBBLEWRAP
			SH_FAKEGOLD = SH_THUNDERCOIN
			SH_FAKEFLOWER = SH_FORCE|1

			MARIOSHIELDS = {
				[SH_NONE] = true,
				[SH_SUPERBALL] = true,
				[SH_CAPE] = true,
				[SH_BALLOON] = true,
				[SH_FIREFLOWER] = true,
				[SH_FAKEGOLD] = true,
				[SH_GOLDFLOWER] = true,
				[SH_ICEFLOWER] = true,
				[SH_FAKEMINI] = true,
				[SH_MINI] = true,
				[SH_FAKEMETAL] = true,
				[SH_METAL] = true,
			}

			MARIOFIREPOWERS = {
				[SH_SUPERBALL] = true,
				[SH_FIREFLOWER] = true,
				[SH_GOLDFLOWER] = true,
				[SH_ICEFLOWER] = true,
			}

		else
			print("Mario can no longer receive his powerups.")
			
			MARIOSHIELDS = {
				[SH_NONE] = true,
				[SH_FIREFLOWER] = true,
				[SH_GOLDFLOWER] = true,
				[SH_MINI] = true,
				[SH_METAL] = true,
			}

			MARIOFIREPOWERS = {
				[SH_FIREFLOWER] = true,
				[SH_GOLDFLOWER] = true,
			}
			
			SH_FAKEBALL = INT8_MIN
			SH_SUPERBALL = INT8_MIN
			SH_CAPE = INT8_MIN
			SH_BALLOON = INT8_MIN
			SH_FAKEMETAL = INT8_MIN
			SH_FAKEMINI = INT8_MIN
			SH_SHOE = INT8_MIN
			SH_ICEFLOWER = INT8_MIN
			SH_FAKEGOLD = INT8_MIN
			SH_FAKEFLOWER = INT8_MIN
		end
	end
}))

//mariosecondcolor command
local mariosecondcolor = function(player, arg)
	if arg
		local color = R_GetColorByName(arg)
		if arg == "0" or arg == "off"
			player.mariosecondcolor = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/SecondColor.dat", "w+")
				file:write(0)
				file:close()
			end
		elseif color and skincolors[color].accessible
			player.mariosecondcolor = color
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/SecondColor.dat", "w+")
				if color == 0
					file:write(0)
				else
					file:write(R_GetNameByColor(color))
				end
				file:close()
			end
		else
			CONS_Printf(player, "Invalid color!")
		end
	else
		CONS_Printf(player, "mariosecondcolor - Sets the color of Mario's overalls. When off, the color is chosen automatically.")
	end
end
COM_AddCommand("mariosecondcolor", mariosecondcolor)
COM_AddCommand("mariosecondcolor2", mariosecondcolor, COM_SPLITSCREEN)

//marioattackbutton command
local marioattackbutton = function(player, arg)
	if arg
		if arg == "0" or arg == "default" then arg = "custom1" end
		if buttonconv[arg] or buttonconv2[tonumber(arg)]
			if buttonconv[arg]
				player.marioattackbutton = buttonconv[arg]
			else
				player.marioattackbutton = tonumber(arg)
			end
			
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/AttackButton.dat", "w+")
				file:write(player.marioattackbutton)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "marioattackbutton - Sets the button used for Mario's attacks.")
		if not player.marioattackbutton
			CONS_Printf(player, "Currently custom1.")
		elseif not buttonconv2[player.marioattackbutton]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..buttonconv2[player.marioattackbutton]..".")
		end
	end
end
COM_AddCommand("marioattackbutton", marioattackbutton)
COM_AddCommand("marioattackbutton2", marioattackbutton, COM_SPLITSCREEN)

//mariocrouchbutton command
local mariocrouchbutton = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "default" then arg = "spin" end
		if buttonconv[arg] or buttonconv2[tonumber(arg)]
			if buttonconv[arg]
				player.mariocrouchbutton = buttonconv[arg]
			else
				player.mariocrouchbutton = tonumber(arg)
			end
			
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/CrouchButton.dat", "w+")
				file:write(player.mariocrouchbutton)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "mariocrouchbutton - Sets the button used for Mario's crouch moves.")
		if not player.mariocrouchbutton
			CONS_Printf(player, "Currently spin.")
		elseif not buttonconv2[player.mariocrouchbutton]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..buttonconv2[player.mariocrouchbutton]..".")
		end
	end
end
COM_AddCommand("mariocrouchbutton", mariocrouchbutton)
COM_AddCommand("mariocrouchbutton2", mariocrouchbutton, COM_SPLITSCREEN)

//marioabilitybutton command
local marioabilitybutton = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "default" then arg = "fire" end
		if buttonconv[arg] or buttonconv2[tonumber(arg)]
			if buttonconv[arg]
				player.marioabilitybutton = buttonconv[arg]
			else
				player.marioabilitybutton = tonumber(arg)
			end
			
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/AbilityButton.dat", "w+")
				file:write(player.marioabilitybutton)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "marioabilitybutton - Sets the button used for Mario's powerup moves.")
		if not player.marioabilitybutton
			CONS_Printf(player, "Currently fire.")
		elseif not buttonconv2[player.marioabilitybutton]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..buttonconv2[player.marioabilitybutton]..".")
		end
	end
end
COM_AddCommand("marioabilitybutton", marioabilitybutton)
COM_AddCommand("marioabilitybutton2", marioabilitybutton, COM_SPLITSCREEN)

//mariospinbutton command
local mariospinbutton = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "default" then arg = "firenormal" end
		if buttonconv[arg] or buttonconv2[tonumber(arg)]
			if buttonconv[arg]
				player.mariospinbutton = buttonconv[arg]
			else
				player.mariospinbutton = tonumber(arg)
			end
			
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/SpinButton.dat", "w+")
				file:write(player.mariospinbutton)
				file:close()
			end
		else
			CONS_Printf(player, "Invalid button!")
		end
	else
		CONS_Printf(player, "mariospinbutton - Sets the button used for Mario's spinning.")
		if not player.mariospinbutton
			CONS_Printf(player, "Currently firenormal.")
		elseif not buttonconv2[player.mariospinbutton]
			CONS_Printf(player, "Currently an invalid button!?")
		else
			CONS_Printf(player, "Currently "..buttonconv2[player.mariospinbutton]..".")
		end
	end
end
COM_AddCommand("mariospinbutton", mariospinbutton)
COM_AddCommand("mariospinbutton2", mariospinbutton, COM_SPLITSCREEN)

//mariodive command
local mariodive = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "off"
			player.mariodiveenabled = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/DiveEnabled.dat", "w+")
				file:write(player.mariodiveenabled)
				file:close()
			end
		elseif arg == "1" or arg == "default" or arg == "on"
			player.mariodiveenabled = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/DiveEnabled.dat", "w+")
				file:write(player.mariodiveenabled)
				file:close()
			end
		else
			CONS_Printf(player, "mariodive [on/off] - When off, disables diving using the Attack button.")
			if player.mariodiveenabled == 0
				CONS_Printf(player, "Currently off.")
			else
				CONS_Printf(player, "Currently on.")
			end
		end
	else
		CONS_Printf(player, "mariodive [on/off] - When off, disables diving using the Attack button.")
		if player.mariodiveenabled == 0
			CONS_Printf(player, "Currently off.")
		else
			CONS_Printf(player, "Currently on.")
		end
	end
end
COM_AddCommand("mariodive", mariodive)
COM_AddCommand("mariodive2", mariodive, COM_SPLITSCREEN)

//marioforcehammer command
local marioforcehammer = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "off"
			player.marioforcehammer = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/ForceHammer.dat", "w+")
				file:write(player.marioforcehammer)
				file:close()
			end
		elseif arg == "1" or arg == "default" or arg == "on"
			player.marioforcehammer = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/ForceHammer.dat", "w+")
				file:write(player.marioforcehammer)
				file:close()
			end
		else
			CONS_Printf(player, "marioforcehammer [on/off] - When on, forces the Attack button to always use Mario's hammer.")
			if player.marioforcehammer
				CONS_Printf(player, "Currently on.")
			else
				CONS_Printf(player, "Currently off.")
			end
		end
	else
		CONS_Printf(player, "marioforcehammer [on/off] - When on, forces the Attack button to always use Mario's hammer.")
		if player.marioforcehammer
			CONS_Printf(player, "Currently on.")
		else
			CONS_Printf(player, "Currently off.")
		end
	end
end
COM_AddCommand("marioforcehammer", marioforcehammer)
COM_AddCommand("marioforcehammer2", marioforcehammer, COM_SPLITSCREEN)

//mariospin command
local mariospin = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "off"
			player.mariospinenabled = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/SpinEnabled.dat", "w+")
				file:write(player.mariospinenabled)
				file:close()
			end
		elseif arg == "1" or arg == "default" or arg == "on"
			player.mariospinenabled = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Mario/SpinEnabled.dat", "w+")
				file:write(player.mariospinenabled)
				file:close()
			end
		else
			CONS_Printf(player, "mariospin [on/off] - When off, disables spin jumping with the movement keys.")
			if player.mariospinenabled == 0
				CONS_Printf(player, "Currently off.")
			else
				CONS_Printf(player, "Currently on.")
			end
		end
	else
		CONS_Printf(player, "mariospin [on/off] - When off, disables spin jumping with the movement keys.")
		if player.mariospinenabled == 0
			CONS_Printf(player, "Currently off.")
		else
			CONS_Printf(player, "Currently on.")
		end
	end
end
COM_AddCommand("mariospin", mariospin)
COM_AddCommand("mariospin2", mariospin, COM_SPLITSCREEN)

//Apply the I/O for the netgame commands when spawning
addHook("PlayerSpawn", function(player)
	//I/O maybe
	if io and player == consoleplayer
		if player.mariosecondcolor == nil
			local file = io.openlocal("client/Mario/SecondColor.dat")
			if file
				local num = file:read("*l")
				if num
					COM_BufInsertText(consoleplayer, "mariosecondcolor \""..num.."\"")
				end
				file:close()
			end
		end
		
		if player.marioattackbutton == nil
			local file = io.openlocal("client/Mario/AttackButton.dat")
			if file
				local num = file:read("*n")
				if num
					COM_BufInsertText(consoleplayer, "marioattackbutton "..num)
				end
				file:close()
			end
		end
		
		if player.mariocrouchbutton == nil
			local file = io.openlocal("client/Mario/CrouchButton.dat")
			if file
				local num = file:read("*n")
				if num
					COM_BufInsertText(consoleplayer, "mariocrouchbutton "..num)
				end
				file:close()
			end
		end
		
		if player.marioabilitybutton == nil
			local file = io.openlocal("client/Mario/AbilityButton.dat")
			if file
				local num = file:read("*n")
				if num
					COM_BufInsertText(consoleplayer, "marioabilitybutton "..num)
				end
				file:close()
			end
		end
		
		if player.mariospinbutton == nil
			local file = io.openlocal("client/Mario/SpinButton.dat")
			if file
				local num = file:read("*n")
				if num
					COM_BufInsertText(consoleplayer, "mariospinbutton "..num)
				end
				file:close()
			end
		end
		
		if player.mariodiveenabled == nil
			local file = io.openlocal("client/Mario/DiveEnabled.dat")
			if file
				local num = file:read("*l")
				if num
					COM_BufInsertText(consoleplayer, "mariodive "..num)
				end
				file:close()
			end
		end
		
		if player.marioforcehammer == nil
			local file = io.openlocal("client/Mario/ForceHammer.dat")
			if file
				local num = file:read("*l")
				if num
					COM_BufInsertText(consoleplayer, "marioforcehammer "..num)
				end
				file:close()
			end
		end
		
		if player.mariospinenabled == nil
			local file = io.openlocal("client/Mario/SpinEnabled.dat")
			if file
				local num = file:read("*l")
				if num
					COM_BufInsertText(consoleplayer, "mariospin "..num)
				end
				file:close()
			end
		end
	end
end)