//
//Support for different Gametypes and Mods
//The BattleMod support is only half-baked support simply so he works, don't expect proper balance
//

//Should we be allowed to reward free score and 1ups?
rawset(_G, "MarioScoreGametype", function()
	return not G_CoopGametype() or ultimatemode or G_IsSpecialStage() //gametyperules & GTR_POINTLIMIT (Chaos benefits from this too you know!)
end)

//Are we in ultimate mode?
rawset(_G, "MarioUltimateMode", function()
	return ultimatemode or gametype == GT_UCOOP or gametype == GT_TUCOOP
end)

//Don't let coins award score in score gametypes
addHook("MobjSpawn", function(mobj)
	if MarioScoreGametype()
		mobj.fuse = 1
	end
end, (freeslot("MT_COINAWARD") or MT_COINAWARD))

//Footstep support
if not PlayerAnimInfo
	rawset(_G, "PlayerAnimInfo", {})
end
PlayerAnimInfo["mario"] = {
	["runFrames"] = {0, 2},
	["dashFrames"] = {0, 2},
	["walkFrames"] = {3, 7},
	["waitFrames"] = {-1},
	["milnekickFrames"] = {0, 4},
	["run"] = true,
	["dash"] = true,
	["walk"] = true,
	["idle"] = true,
	["wait"] = false,
	["milnekick"] = true,
	["superRun"] = true,
	["superDash"] = true,
	["superWalk"] = true,
	["superIdle"] = true,
	["superWait"] = false
}
PlayerAnimInfo["luigi"] = PlayerAnimInfo["mario"]

//BattleMod Support
if srb2p then return end
local ScriptLoaded = false
addHook("ThinkFrame", function()
	if not(CBW_Battle) or ScriptLoaded then return end
	ScriptLoaded = true
	local B = CBW_Battle
	local CV = B.Console
	
	local function GarbagePriorityM(player)
		local mo = player.mo
		if mo.state == S_PLAY_MELEE or mo.state == S_PLAY_MELEE_FINISH
		or mo.state == S_PLAY_MELEE_LANDING
			B.SetPriority(player,0,0,"amy_melee",2,1,"hammer strike")
		elseif mo.state == S_MARIO_CAPESPIN
			B.SetPriority(player,0,1,nil,0,1,"cape")
		elseif player.mariogroundpound and not P_IsObjectOnGround(mo)
			B.SetPriority(player,0,0,"fang_tailbounce",3,3,"ground pound")
		end
	end
	
	//Stats
	B.SkinVars["mario"] = {
		func_priority_ext = GarbagePriorityM,
	}
	B.SkinVars["luigi"] = B.SkinVars["mario"]
	
	//No shield actives!
	B.MarioDoShieldActive = B.DoShieldActive
	B.DoShieldActive = function(player)
		if not IsMario(player)
			B.MarioDoShieldActive(player)
		end
	end
	
	//Fix Fire Flowers taking away your entire shield stock
	B.MarioShieldStock = B.ShieldStock
	B.ShieldStock = function(player)
		if IsMario(player)
		and player.powers[pw_shield] == SH_FIREFLOWER
			if not(CV.ShieldStock.value) then return end	
			//Go no further if we're not in the game
			if (player.spectator) then return end
			player.pity = 0 //Disable the "pity" mechanic from ringslinger.
		else
			B.MarioShieldStock(player)
		end
	end
end)