//
//The Lua for Mario's menu
//I am going to die
//

sfxinfo[freeslot("sfx_mrselc")].caption = "Click"
sfxinfo[freeslot("sfx_mrup")].caption = "Menu up"
sfxinfo[freeslot("sfx_mrdown")].caption = "Menu down"
sfxinfo[freeslot("sfx_mrenab")].caption = "/"
sfxinfo[freeslot("sfx_mrdisa")].caption = "/"

local MAINTOP = 60
local MAINBOTTOM = MAINTOP + 40
local MAINLEFT = 80
local MAINRIGHT = MAINLEFT + 100

local CHANGERDIFF = 80
local CHANGERLEFT = MAINLEFT - CHANGERDIFF/2
local CHANGERBOTTOM = 160

local BLK_WIDTH = 48/2
local BLK_HEIGHT = 32/2
local BLK_SELECTTIMER = TICRATE/4

local BLK_PAGE = 1 //Page the block displays on
local BLK_X = 2 //X position 
local BLK_Y = 3 //Y position
local BLK_SCALE = 4 //Scale
local BLK_FUNCTION = 5 //Function to run on clicking the block
local BLK_GRAPHIC = 6 //The block's graphic, can be a function
local BLK_ENDFUNCTION = 7 //Run the function after the click animation
local BLK_TEXT = 8 //What text to display with the block
local BLK_SIDETEXT = 9 //Determines if the text should be on the side

local PAGE_MAIN = 1 << 0
local PAGE_ATTACK = 1 << 1
local PAGE_CROUCH = 1 << 2
local PAGE_ABILITY = 1 << 3
local PAGE_SPIN = 1 << 4
local PAGE_CONTROLS = 1 << 5
local PAGE_CREDITS = 1 << 6
local PAGE_COLOR = 1 << 7

local PAGE_TITLES = {
	[PAGE_MAIN] = "OPTIONS",
	[PAGE_CONTROLS] = "CONTROLS",
	[PAGE_ATTACK] = "ATTACK___BUTTON",
	[PAGE_CROUCH] = "CROUCH___BUTTON",
	[PAGE_ABILITY] = "ABILITY___BUTTON",
	[PAGE_SPIN] = "SPIN___BUTTON",
	[PAGE_CREDITS] = "CREDITS",
	[PAGE_COLOR] = "SECOND___COLOR",
}

//Credits
local CREDITSTEXT = "Sprites by DirkTheHusky and Kaching"
+ "\n" + "Lua and Mega Mushroom jingle by SMS Alfredo"
+ "\n" + "Original Mario sprite by MotorRoach"

+ "\n\n" + "CSS art assistance from BendyTheDesigner"
+ "\n" + "Death sprite assistance from AaronKasarion"
+ "\n" + "Power-up/Coin/Particle sprites by Team Blue Spring"

+ "\n\n" + "Crystal Star Lua by Frostiikin and Icezer"
+ "\n" + "Continue/Drowning music by rumia1 - Life HUD by Inazuma"
+ "\n" + "SM64 File Select textures ripped by Booscaster"

+ "\n\n" + "Special thanks: The Adventurer's Guild / Roach's Gas Station"
+ "\n" + "and toaster for the original death pause Lua"

//Define all the blocks and their functions
local BLK_BLOCKS = {
	//
	//Page changers
	//
	
	//Quitter (1)
	{PAGE_MAIN|PAGE_CONTROLS|PAGE_CREDITS|PAGE_COLOR, CHANGERLEFT, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		player.mariomenu = false
		S_StartSound(nil, sfx_mrdown, player)
		P_RestoreMusic(player)
	end,
	"MRBLKGREEN1", true, "Quit"
	},
	
	//Second color (2)
	{PAGE_MAIN|PAGE_CONTROLS|PAGE_CREDITS, CHANGERLEFT + CHANGERDIFF, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_COLOR
	end,
	"MRBLKBLUE1", true, "Second", "Color"
	},
	
	//Return from Second color (2)
	{PAGE_COLOR, CHANGERLEFT + CHANGERDIFF, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrdown, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_MAIN
	end,
	"MRBLKYELLOW1", true, "Return"
	},
	
	//Controls (3)
	{PAGE_MAIN|PAGE_CREDITS|PAGE_COLOR, CHANGERLEFT + CHANGERDIFF*2, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_CONTROLS
	end,
	"MRBLKRED1", true, "Controls"
	},
	
	//Return from Controls (3)
	{PAGE_CONTROLS, CHANGERLEFT + CHANGERDIFF*2, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrdown, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_MAIN
	end,
	"MRBLKYELLOW1", true, "Return"
	},
	
	//Credits (4)
	{PAGE_MAIN|PAGE_CONTROLS|PAGE_COLOR, CHANGERLEFT + CHANGERDIFF*3, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_CREDITS
	end,
	"MRBLKMAGENTA1", true, "Credits"
	},
	
	//Return from Credits (4)
	{PAGE_CREDITS, CHANGERLEFT + CHANGERDIFF*3, CHANGERBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrdown, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_MAIN
	end,
	"MRBLKYELLOW1", true, "Return"
	},
	
	//
	//Main Page
	//
	
	//Top left (voice toggle)
	{PAGE_MAIN, MAINLEFT, MAINTOP, FRACUNIT,
	function(player, block)
		if player != consoleplayer then return end
		if mariovoice.value
			if skins[player.skin].name == "luigi"
				S_StartSound(nil, sfx_lufall, player)
			else
				S_StartSound(nil, sfx_mrfall, player)
			end
			COM_BufInsertText(consoleplayer, "mariovoice off")
		else
			if skins[player.skin].name == "luigi"
				S_StartSound(nil, sfx_luokie, player)
			else
				S_StartSound(nil, sfx_mrokie, player)
			end
			COM_BufInsertText(consoleplayer, "mariovoice on")
		end
	end,
	function(player, block)
		if mariovoice.value
			return "MRBLKMARIO"
		else
			return "MRBLKBLARIO"
		end
	end, true, "Voice\nClips", true},
	
	//Bottom left (death jingle toggle)
	{PAGE_MAIN, MAINLEFT, MAINBOTTOM, FRACUNIT,
	function(player, block)
		if player != consoleplayer then return end
		if mariodeathjingle.value
			S_StartSound(nil, skins["mario"].soundsid[SKSPLDET1], player)
			COM_BufInsertText(consoleplayer, "mariodeathjingle off")
		else
			S_StartSound(nil, sfx_marioa, player)
			COM_BufInsertText(consoleplayer, "mariodeathjingle on")
		end
	end,
	function(player, block)
		if mariodeathjingle.value
			return "MRBLKMARIO"
		else
			return "MRBLKBLARIO"
		end
	end, true, "Death\nJingle", true},
	
	//Top right (hammer toggle)
	{PAGE_MAIN, MAINRIGHT, MAINTOP, FRACUNIT,
	function(player, block)
		if player.marioforcehammer
			S_StartSound(nil, sfx_mrhhit, player)
			player.marioforcehammer = 0
		else
			S_StartSound(nil, sfx_mrhmr2, player)
			player.marioforcehammer = 1
		end
		if io and player == consoleplayer
			local file = io.openlocal("client/Mario/ForceHammer.dat", "w+")
			file:write(player.marioforcehammer)
			file:close()
		end
	end,
	function(player, block)
		if player.marioforcehammer
			return "MRBLKMARIO"
		else
			return "MRBLKBLARIO"
		end
	end, true, "Force\nHammer", true},
	
	//Bottom right (spin toggle)
	{PAGE_MAIN, MAINRIGHT, MAINBOTTOM, FRACUNIT,
	function(player, block)
		if player.mariospinenabled == 0
			S_StartSound(nil, sfx_mrspin, player)
			player.mariospinenabled = 1
		else
			S_StartSound(nil, sfx_mrkill, player)
			player.mariospinenabled = 0
		end
		if io and player == consoleplayer
			local file = io.openlocal("client/Mario/SpinEnabled.dat", "w+")
			file:write(player.mariospinenabled)
			file:close()
		end
	end,
	function(player, block)
		if player.mariospinenabled == 0
			return "MRBLKBLARIO"
		else
			return "MRBLKMARIO"
		end
	end, true, "Spin on\nStick", true},
	
	//
	//Second Color
	//
	
	//Custom Second Color toggle
	{PAGE_COLOR, MAINLEFT, MAINTOP, FRACUNIT,
	function(player, block)
		if player.mariosecondcolor
			S_StartSound(nil, sfx_mrdisa, player)
			player.mariosecondcolor = 0
		else
			S_StartSound(nil, sfx_mrenab, player)
			player.mariosecondcolor = GetMarioOverallsColor(player.skincolor, player)
		end
		if io and player == consoleplayer
			local file = io.openlocal("client/Mario/SecondColor.dat", "w+")
			if player.mariosecondcolor == 0
				file:write(0)
			else
				file:write(R_GetNameByColor(player.mariosecondcolor))
			end
			file:close()
		end
	end,
	function(player, block)
		if player.mariosecondcolor
			return "MRBLKMARIO"
		else
			return "MRBLKBLARIO"
		end
	end, true, "Custom\nColor", true},
	
	//Main color swapper
	{PAGE_COLOR, MAINLEFT, MAINBOTTOM, FRACUNIT,
	function(player, block)
		if not player.mariosecondcolor
			S_StartSound(nil, sfx_mrenab, player)
			player.mariosecondcolor = GetMarioOverallsColor(player.skincolor, player)
		end
		if player.mariocursorspin
			player.mariosecondcolor = M_GetColorBefore($)
			while player.mariosecondcolor < #skincolors
			and (not player.mariosecondcolor
			or not skincolors[player.mariosecondcolor].accessible)
				player.mariosecondcolor = M_GetColorBefore($)
			end
		else
			player.mariosecondcolor = M_GetColorAfter($)
			while player.mariosecondcolor < #skincolors
			and (not player.mariosecondcolor
			or not skincolors[player.mariosecondcolor].accessible)
				player.mariosecondcolor = M_GetColorAfter($)
			end
		end
		
		if io and player == consoleplayer
			local file = io.openlocal("client/Mario/SecondColor.dat", "w+")
			if player.mariosecondcolor == 0
				file:write(0)
			else
				file:write(R_GetNameByColor(player.mariosecondcolor))
			end
			file:close()
		end
	end,
	function(player, block) return GetMarioOverallsColor(player.skincolor, player) end,
	false, "special", true},
	
	//
	//Controls
	//
	
	//Top Left (Crouch)
	{PAGE_CONTROLS, MAINLEFT, MAINTOP, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_CROUCH
	end,
	"MRBLKCROUCH", true, "Crouch\nButton", true
	},
	
	//Top Right (Attack)
	{PAGE_CONTROLS, MAINRIGHT, MAINTOP, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_ATTACK
	end,
	"MRBLKATTACK", true, "Attack\nButton", true
	},
	
	//Bottom Left (Spin)
	{PAGE_CONTROLS, MAINLEFT, MAINBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_SPIN
	end,
	"MRBLKSPIN", true, "Spin\nButton", true
	},
	
	//Bottom Right (Ability)
	{PAGE_CONTROLS, MAINRIGHT, MAINBOTTOM, FRACUNIT,
	function(player, block)
		S_StartSound(nil, sfx_mrup, player)
		player.mariomenutrans = 0
		player.mariomenupage = PAGE_ABILITY
	end,
	"MRBLKABILITY", true, "Ability\nButton", true
	},
}
//
//Key setters
//

//Yes, more of these
local buttonconv3 = {
	["Spin"] = BT_SPIN,
	["Fire"] = BT_ATTACK,
	["Fire Normal"] = BT_FIRENORMAL,
	
	["Next Wpn"] = BT_WEAPONNEXT,
	["Prev Wpn"] = BT_WEAPONPREV,
	["Toss Flag"] = BT_TOSSFLAG,
	
	["Custom 1"] = BT_CUSTOM1,
	["Custom 2"] = BT_CUSTOM2,
	["Custom 3"] = BT_CUSTOM3,
}
local buttonconv4 = {
	{"Fire", BT_ATTACK},
	{"Fire Normal", BT_FIRENORMAL},
	
	{"Next Wpn", BT_WEAPONNEXT},
	{"Prev Wpn", BT_WEAPONPREV},
	{"Toss Flag", BT_TOSSFLAG},
	
	{"Custom 1", BT_CUSTOM1},
	{"Custom 2", BT_CUSTOM2},
	{"Custom 3", BT_CUSTOM3},
}
buttonconv4[0] = {"Spin", BT_SPIN}

//For the button setting
local keysetbuttons = {
	[PAGE_ATTACK] = "AttackButton",
	[PAGE_CROUCH] = "CrouchButton",
	[PAGE_ABILITY] = "AbilityButton",
	[PAGE_SPIN] = "SpinButton",
}
local keysetdefaults = {
	[PAGE_ATTACK] = "Custom 1",
	[PAGE_CROUCH] = "Spin",
	[PAGE_ABILITY] = "Fire",
	[PAGE_SPIN] = "Fire Normal",
}

local KEYSETTER_FUNCTION = function(player, block)
	local button = keysetbuttons[player.mariomenupage]
	if button != nil
		player["mario" + string.lower(button)] = buttonconv3[block[BLK_TEXT]] or $
		if io and player == consoleplayer
			local file = io.openlocal("client/Mario/" + button + ".dat", "w+")
			file:write(player["mario" + string.lower(button)])
			file:close()
		end
	end
	S_StartSound(nil, sfx_mrdown, player)
	player.mariomenutrans = 0
	player.mariomenupage = PAGE_CONTROLS
end

local KEYSETTER_GRAPHIC = function(player, block)
	local button = keysetbuttons[player.mariomenupage]
	if button != nil
	and (player["mario" + string.lower(button)] == buttonconv3[block[BLK_TEXT]]
	or (player["mario" + string.lower(button)] == nil
	and block[BLK_TEXT] == keysetdefaults[player.mariomenupage]))
		return "MRBLKGREY2"
	else
		return "MRBLKGREY1"
	end
end

//Add all the key setter blocks in one go
for i, thetable in pairs(buttonconv4) do
	local string = thetable[1]
	local button = thetable[2]
	
	table.insert(BLK_BLOCKS,
	{PAGE_ATTACK|PAGE_CROUCH|PAGE_ABILITY|PAGE_SPIN,
	MAINLEFT + CHANGERDIFF*(i % 3), //X
	MAINTOP + CHANGERDIFF*(i / 3)*2/3, //Y
	FRACUNIT, KEYSETTER_FUNCTION, KEYSETTER_GRAPHIC, true, string})
end

//mariomenu command
local function mariomenu(player, arg)
	local mo = player.mo
	if modeattacking or titlemapinaction or tutorialmode or player.playerstate
	or (mo and mo.valid and not mo.health)
		CONS_Printf(player, "You can't enter Mario's menu right now.")
		return
	end
	
	if player == consoleplayer and not CV_FindVar("showhud").value
		COM_BufInsertText(player, "showhud on")
	end
	
	player.mariomenu = not $
	if player.mariomenu
		player.mariomenupage = PAGE_MAIN
		S_StartSound(nil, sfx_mrup, player)
		P_PlayJingleMusic(player, "MRMENU", nil, true, JT_OTHER)
	else
		S_StartSound(nil, sfx_mrdown, player)
		P_RestoreMusic(player)
	end
end
COM_AddCommand("mariomenu", mariomenu)
COM_AddCommand("mariomenu2", mariomenu, COM_SPLITSCREEN)

addHook("ShouldJingleContinue", function(player, musname)
	if musname != "mrmenu" return end
	if player and player.mariomenu
		return true
	else
		return false
	end
end)

//I know multiple hooks of the same type are stupid, but there's no way I'm
//shoving this into mario.lua
addHook("PreThinkFrame", do for player in players.iterate
	local menublocks = BLK_BLOCKS
	local mo = player.mo
	
	//Intialize
	if player.mariomenutrans == nil
		player.mariomenutrans = 0
		player.mariocursorx = 160
		player.mariocursory = 100
		player.mariomenupage = PAGE_MAIN
		player.marioblocktimers = {}
		
	//Main code
	elseif player.mariomenu and not player.playerstate
	and not (mo and mo.valid and not mo.health)
		player.mariomenutrans = $ + 1
		
		//Button detection
		if player.cmd.buttons & BT_JUMP and player.mariocursorjump != nil
			player.mariocursorjump = $ + 1
		else
			player.mariocursorjump = 0
		end
		if player.cmd.buttons & (BT_SPIN|BT_CUSTOM1)
		and player.mariocursorspin != nil
			player.mariocursorspin = $ + 1
		else
			player.mariocursorspin = 0
		end
		
		//Prevent movement
		local forwardmove = player.cmd.forwardmove
		local sidemove = player.cmd.sidemove
		player.cmd.forwardmove = 0
		player.cmd.sidemove = 0
		player.cmd.buttons = 0
		
		//Do block code
		for id, block in pairs(menublocks) do
			//Click on it
			if player.mariomenupage & block[BLK_PAGE]
			and not (player.marioblocktimers[id] and block[BLK_ENDFUNCTION])
			and (player.mariocursorjump == 1 or player.mariocursorspin == 1)
			and player.mariocursorx <= block[BLK_X] + BLK_WIDTH
			and player.mariocursorx >= block[BLK_X] - BLK_WIDTH
			and player.mariocursory <= block[BLK_Y] + BLK_HEIGHT
			and player.mariocursory >= block[BLK_Y] - BLK_HEIGHT
				player.marioblocktimers[id] = BLK_SELECTTIMER
				S_StartSound(nil, sfx_mrselc, player)
				if not block[BLK_ENDFUNCTION]
					block[BLK_FUNCTION](player, block)
				end
				
			elseif player.marioblocktimers[id]
				player.marioblocktimers[id] = $ - 1
				if block[BLK_ENDFUNCTION]
					if not player.marioblocktimers[id]
						block[BLK_FUNCTION](player, block)
					end
					continue
				end
			end
		end
		
		//Move cursor
		player.mariocursorx = $ + sidemove/5
		player.mariocursory = $ - forwardmove/5
		
		player.mariocursorx = min(max($,0),320)
		player.mariocursory = min(max($,0),200)
		
	//Fade away
	elseif player.mariomenutrans
		player.mariomenutrans = min($ - 1, 9)
		if player.mariomenu
			player.mariomenu = false
			P_RestoreMusic(player)
		end
	end
end end)

hud.add(function(v, player, cam)
	if not player.mariomenutrans then return end
	
	local menublocks = BLK_BLOCKS
	local menupage = player.mariomenupage
	local skin = IsMario(player) and skins[player.skin].name or "mario"
	local skincolor = player.skincolor
	local secondcolor = GetMarioOverallsColor(skincolor, player)
	local trans = min(max((10 - player.mariomenutrans) << FF_TRANSSHIFT, 0), V_90TRANS) | V_PERPLAYER
	
	//Background (Cropped for splitscreen)
	local patch = v.cachePatch("SPECTILE")
	local width = patch.width*FRACUNIT*2
	local height = patch.height
	height = ($ + patch.topoffset - ($ - v.height()/v.dupy()))*FRACUNIT*2
	
	v.drawCropped(0, 0, 2*FRACUNIT, 2*FRACUNIT, patch, 
	min(max((10 - player.mariomenutrans/2) << FF_TRANSSHIFT, V_50TRANS), V_90TRANS)
	| V_PERPLAYER | V_SNAPTOLEFT | V_SNAPTOTOP, nil, 0,0, width, height)
	
	//Title
	v.drawNameTag(160, 8, PAGE_TITLES[menupage], trans|V_CENTERNAMETAG,
	skincolor, secondcolor)
	
	//Credits text
	if menupage == PAGE_CREDITS
		v.drawString(16, 30, CREDITSTEXT, trans|V_ALLOWLOWERCASE|V_RETURN8, "thin")
	end
	
	//Mario in the Second Color menu
	if menupage == PAGE_COLOR
		local x = MAINRIGHT + CHANGERDIFF/4
		local y = MAINBOTTOM + CHANGERDIFF/8 + 2
		local sprite2 = SPR2_WALK
		local frame = (leveltime/4) % 8
		local rotation = ((leveltime/4/8) % 8) + 1
		
		local dummy, flipped = v.getSprite2Patch(skin, sprite2, false, frame, rotation)
		flipped = $ and V_FLIP or 0
		
		v.draw(x, y,
		v.getSprite2Patch(skin, sprite2, false, frame, rotation),
		trans|flipped, v.getColormap(skin, skincolor))
		
		v.draw(x, y,
		v.getSprite2Patch(skin, sprite2, true, frame, rotation),
		trans|flipped, v.getColormap(skin, secondcolor))
	end
	
	//Render blocks
	for id, block in pairs(menublocks) do
		if not (menupage & block[BLK_PAGE]) then continue end
		
		local scale = block[BLK_SCALE]
		if player.marioblocktimers[id]
			scale = $ + (abs(BLK_SELECTTIMER/2 - player.marioblocktimers[id]) - BLK_SELECTTIMER/2)*FRACBITS*256
		end
		
		local graphic = block[BLK_GRAPHIC]
		local color = skincolor
		if type(graphic) == "function" then graphic = $(player, block) end
		if type(graphic) == "number"
			color = graphic
			if player.mariosecondcolor
				graphic = "MRBLKCOLOR2"
			else
				graphic = "MRBLKCOLOR1"
			end
		end
		
		v.drawScaled(block[BLK_X]*FRACUNIT, block[BLK_Y]*FRACUNIT,
		scale, v.cachePatch(graphic), trans,
		v.getColormap(0, color))
		
		local text = block[BLK_TEXT]
		if text
			if text == "special"
				text = R_GetNameByColor(color)
				v.drawString(block[BLK_X] + BLK_WIDTH + 2, block[BLK_Y] - 4,
				text, trans, "left")
			elseif block[BLK_SIDETEXT] and type(block[BLK_SIDETEXT]) != "string"
				v.drawString(block[BLK_X] + BLK_WIDTH + 2, block[BLK_Y] - 10,
				text, trans, "left")
			else
				v.drawString(block[BLK_X], block[BLK_Y] + BLK_HEIGHT + 1,
				text, trans, "center")
				
				if block[BLK_SIDETEXT]
					v.drawString(block[BLK_X], block[BLK_Y] + BLK_HEIGHT + 9,
					block[BLK_SIDETEXT], trans, "center")
				end
			end
		end
	end
	
	//Cursor
	local HAND1 = v.cachePatch("MRHAND1")
	local HAND2 = v.cachePatch("MRHAND2")
	v.drawScaled(player.mariocursorx*FRACUNIT, player.mariocursory*FRACUNIT, FRACUNIT,
	(player.mariocursorjump or player.mariocursorspin) and HAND1 or HAND2, trans)
end)