//
//The Lua for displaying Mario's powerups on monitors
//And no, this doesn't contain the code for spawning them, that's one back!
//

if srb2p then return end

freeslot("SPR_MMON")

//Define which states we're going to display over
local MonitorStates = {
	S_RING_BOX,
	S_PITY_BOX,
	S_ATTRACT_BOX,
	S_FORCE_BOX,
	S_ARMAGEDDON_BOX,
	S_WHIRLWIND_BOX,
	S_ELEMENTAL_BOX,
	S_SNEAKERS_BOX,
	S_INVULN_BOX,
	S_EGGMAN_BOX,
	S_PITY_GOLDBOX,
	S_FLAMEAURA_BOX,
	S_BUBBLEWRAP_BOX,
	S_THUNDERCOIN_BOX,
	S_ATTRACT_GOLDBOX,
	S_FORCE_GOLDBOX,
	S_ARMAGEDDON_GOLDBOX,
	S_WHIRLWIND_GOLDBOX,
	S_ELEMENTAL_GOLDBOX,
	S_SNEAKERS_GOLDBOX,
	S_INVULN_GOLDBOX,
	S_EGGMAN_GOLDBOX,
	S_FLAMEAURA_GOLDBOX,
	S_BUBBLEWRAP_GOLDBOX,
	S_THUNDERCOIN_GOLDBOX,
}

//Define which sprites we'll use
local MonitorSprites = {
	[SPR_TVRI] = 0, //S_RING_BOX
	[SPR_TVPI] = 12, //S_PITY_BOX
	[SPR_TVAT] = 3, //S_ATTRACT_BOX
	[SPR_TVFO] = 9, //S_FORCE_BOX
	[SPR_TVAR] = 5, //S_ARMAGEDDON_BOX
	[SPR_TVWW] = 6, //S_WHIRLWIND_BOX
	[SPR_TVEL] = 4, //S_ELEMENTAL_BOX
	[SPR_TVSS] = 2, //S_SNEAKERS_BOX
	[SPR_TVIV] = 1, //S_INVULN_BOX
	[SPR_TVEG] = 10, //S_EGGMAN_BOX
	[SPR_TVFL] = 11, //S_FLAMEAURA_BOX
	[SPR_TVBB] = 7, //S_BUBBLEWRAP_BOX
	[SPR_TVZP] = 8, //S_THUNDERCOIN_BOX
}

//Spawn the thing
function A_MarioMonitorThink(actor, var1, var2)
	local frame = MonitorSprites[actor.sprite]
	if frame == nil then return end
	
	//Ice flower instead of fire flower in snow levels
	//Also replace the poison mushroom in Frozen Hillside specifically
	//And also in BattleMod because stupidity
	if (frame == 9 and mapheaderinfo[gamemap].weather == PRECIP_SNOW)
	or (frame == 10 and gamemap == 30 and mapheaderinfo[gamemap].lvlttl == "Frozen Hillside")
		frame = 7
		
	//Shoe in Forest Fortress
	elseif frame >= 3 and frame != 10 and frame != 9
	and gamemap == 32 and mapheaderinfo[gamemap].lvlttl == "Forest Fortress"
		frame = 11
	end
	
	local marioisreal = false
	local maxdist = INT32_MAX
	
	if mariocoins.value and frame == 0
		marioisreal = true
	elseif not mariopowerup.value and frame != 0 and frame != 1 and frame != 10
		marioisreal = false
	elseif multiplayer
		for player in players.iterate
			local mo = player.mo
			if mo and mo.valid and not player.bot
			and not player.spectator and not player.playerstate
				local dist = P_AproxDistance(mo.x - actor.x, mo.y - actor.y)
				if dist < maxdist
					marioisreal = IsMario(mo)
					maxdist = dist
				end
			end
		end
	elseif consoleplayer and consoleplayer.valid and IsMario(consoleplayer)
		marioisreal = true
	end
	
	if marioisreal
		local thok = P_SpawnMobjFromMobj(actor, 0,0,0, MT_OVERLAY)
		
		thok.sprite = SPR_MMON
		thok.frame = frame
		thok.tics = actor.tics + (actor.tics > -1 and 1 or 0)
		
		thok.height = actor.height
		thok.radius = actor.radius
		
		thok.target = actor
		thok.tracer = actor
		thok.flags = $|MF2_LINKDRAW
		
		if actor.flags & MF_GRENADEBOUNCE
			thok.spriteyoffset = $ + FRACUNIT*2
		end
	end
end

//Again for gold
function A_MarioGoldMonitorThink(actor, var1, var2)
	A_GoldMonitorSparkle(actor, var1, var2)
	A_MarioMonitorThink(actor, var1, var2)
end

//Apply the states!
for _, i in ipairs(MonitorStates)
	local state = states[i]
	if state == nil
		//Whoops!
	elseif state.action == A_GoldMonitorSparkle
		state.action = A_MarioGoldMonitorThink
	elseif state.action == nil
		state.action = A_MarioMonitorThink
	end
end

//Give the 1up monitor a mushroom icon instead of Mario's head
function A_Mario1upIcon(actor, var1, var2)
	if IsMario(actor)
		actor.frame = MarioUltimateMode() and 2 or 1
	end
end
states[S_PLAY_BOX1].action = A_Mario1upIcon
states[S_PLAY_ICON1].action = A_Mario1upIcon
states[S_PLAY_ICON3].action = A_Mario1upIcon