//
//Mario in Persona??
//

//Define all the stuff we're gonna use elsewhere
states[freeslot("S_MARIO_HIT1")] = {SPR_MRPT, L|FF_ANIMATE, 14, nil, 6, 2, S_NULL}
states[freeslot("S_MARIO_HIT2")] = {SPR_MRPT, S|FF_ANIMATE, 10, nil, 4, 2, S_NULL}
local nicecolors = {
	SKINCOLOR_BLUE,
	SKINCOLOR_SUPERGOLD5,
	SKINCOLOR_RED,
	SKINCOLOR_MAGENTA,
}
rawset(_G, "MarioDoHit", function(target, strong, nice)
	local h = P_SpawnMobjFromMobj(target, 0,0,0, MT_THOK)
	h.state = strong and S_MARIO_HIT1 or S_MARIO_HIT2
	h.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	if not srb2p or target.type == MT_SPIKE then h.scale = $/2 end
	
	nice = $ != nil and $+1 or 2
	h.color = nicecolors[nice] or nicecolors[2]
	
	return h
end)

rawset(_G, "MarioDoStars", function(target)
	for i = 1, 6
		local h = P_SpawnMobjFromMobj(target, 0,0,0, MT_THOK)
		h.state = S_INVISIBLE
		h.sprite = SPR_MRPT
		h.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		h.blendmode = AST_ADD
		h.color = (i % 2) and SKINCOLOR_SKY or SKINCOLOR_ORANGE
		h.fuse = TICRATE
		if srb2p and target.type == MT_SPIKE then h.scale = $/2 end
		
		h.scalespeed = FixedMul(h.scale, $/2)
		if srb2p then h.scale = $*2 else h.scale = $*3/2 end
		h.destscale = 1
		h.flags = $ &~ MF_NOGRAVITY
		
		h.momx = P_RandomRange(-24, 24)*h.scale/6
		h.momy = P_RandomRange(-24, 24)*h.scale/6
		h.momz = P_RandomRange(2, 24)*h.scale/3
	end
end)

//Now don't!
if not srb2p then return end

sfxinfo[freeslot("sfx_mractn")].caption = "Action Command"
sfxinfo[freeslot("sfx_mrcast")].caption = "/"
sfxinfo[freeslot("sfx_mrorb")].caption = "Fireball"
sfxinfo[freeslot("sfx_mrhit")].caption = "/"

sfxinfo[freeslot("sfx_mrappl")].caption = "Appeal"
sfxinfo[freeslot("sfx_mrslep")].caption = "Sleep!"
sfxinfo[freeslot("sfx_mrattk")].caption = "Select"

sfxinfo[freeslot("sfx_mrrat1")].caption = "OK!"
sfxinfo[freeslot("sfx_mrrat2")].caption = "Good!"
sfxinfo[freeslot("sfx_mrrat3")].caption = "Great!"
sfxinfo[freeslot("sfx_mrrat4")].caption = "Excellent"

sfxinfo[freeslot("sfx_mrbep1")].caption = "Wait"
sfxinfo[freeslot("sfx_mrbep2")].caption = "Release!"
sfxinfo[freeslot("sfx_mrhold")].caption = "/"
sfxinfo[freeslot("sfx_luhold")].caption = "/"

sfxinfo[freeslot("sfx_luchg1")].caption = "Charging"
sfxinfo[freeslot("sfx_luchg2")].caption = "Charging"
sfxinfo[freeslot("sfx_lucorr")].caption = "Correct"
sfxinfo[freeslot("sfx_luwrng")].caption = "Wrong"
sfxinfo[freeslot("sfx_lushck")].caption = "Shock"
sfxinfo[freeslot("sfx_luwhsh")].caption = "Whoosh"
sfxinfo[freeslot("sfx_luthdr")].caption = "/"
sfxinfo[freeslot("sfx_luwind")].caption = "/"

charStats["mario"] = {
	-- GENERAL
	
	//ChrispyChars are reusable so yay
	overlay = MT_MARIO_OVERALLS,
	overlaythink = function(mo)
		if not (mo and mo.valid) then return end
		
		local target = mo.target
		local player = target and target.valid and target.control
		
		if player and multiplayer
			P_TeleportMove(target,
				target.x + target.momx,
				target.y + target.momy,
				target.z + target.momz)
			DoMarioOveralls(player, target, mo)
			P_TeleportMove(target,
				target.x - target.momx,
				target.y - target.momy,
				target.z - target.momz)
		end
	end,

	name = "Mario",			-- This is only for bots / enemies
	basehp = 70,			-- base HP for level 1
	basesp = 30,
	persona = "mario",
	melee_natk = "mario jump",	-- normal melee attack

	wep = "mario_shoes",		-- default weapon.
	weptype = WPT_SHOES|WPT_HAMMER,	-- Equippable weapon type(s)

	atk = 30,	-- attack power of physical attacks
	acc = 85,	-- accuracy of physical attacks
	crit = 5,

	-- ANIMS
	-- Anims are built like this:
	-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
	-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
	anim_stand_bored =	{SPR_PLAY, A, 1, "SPR2_STND"},	-- standing (rare anim)
	anim_guard = 		{SPR_PLAY, A, 1, "SPR2_LAND"},		-- guarding
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
	anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
	anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},	-- attacking
	anim_aoa_end =		{SPR_PLAY, A, B, C, D, 2, "SPR2_TWIN"},	-- jumping out of all-out attack
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- is down
	anim_getup =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets up from down
	anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
	anim_revive =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets revived
	anim_evoker =		{SPR_PLAY, A, 1, "SPR2_STND"},	-- holding evoker to head

	anim_special1 = {SPR_PLAY, D, C, B, A, 2, "SPR2_MLEE"}, -- hammer prep
	anim_special2 = {SPR_PLAY, B, C, D, 1, "SPR2_MLEE"}, -- hammer swing
	anim_special3 = {SPR_PLAY, D, 1, "SPR2_TAL5"},	-- appeal
	anim_special4 = {SPR_PLAY, A, 2, "SPR2_TAL0"}, -- jump start
	anim_special5 = {SPR_PLAY, A, 2, "SPR2_FIRE"}, -- fireball
	anim_special6 = {SPR_PLAY, A, 2, "SPR2_TAL8"}, -- cast

	-- VOICES
	-- Follow this template.
	-- All sounds in there will be *automatically* freeslotted.
	-- For custom characters, call VFX_freeslotC("skinname") OUT OF A THINKFRAME (!)
	-- See Player_Defs.LUA

	vfx_summon = {},	-- Summoning Persona to use a Skill
	vfx_skill = {"sfx_mrthis", "sfx_mrthat", "sfx_mrhoho",
	"sfx_mrhol", "sfx_mrwah", "sfx_mryhaw", "sfx_mryah", "sfx_mryul"},	-- Used a Skill
	vfx_item = {"sfx_mrwawl", "sfx_mruhn", "sfx_mryeho", "sfx_mrwoho", "sfx_mrheho"},		-- Used an item
	vfx_hurt = {"sfx_mrgrua", "sfx_mrhuah", "sfx_mroh", "sfx_mrohho", "sfx_mrow", "sfx_mrwoch"},	-- Sustained damage
	vfx_hurtx = {"sfx_mrahow", "sfx_mrfall", "sfx_mrlava", "sfx_mrscrm"},		-- Sustained heavy damage / Critical hit / Weakness
	vfx_die = {"sfx_mrdie1", "sfx_mrdie2", "sfx_mrdie3", "sfx_mrmama"},	-- Death
	vfx_heal = {"sfx_mrthnk", "sfx_mrtrea", "sfx_mrneed", "sfx_mrprob"},	-- Healed by teammate
	vfx_healself = {"sfx_mrtrea", "sfx_mrneed", "sfx_mrprob"},	-- Healed self
	vfx_kill = {"sfx_mrgotc", "sfx_mrohys", "sfx_mrhaha", "sfx_mrboig"},	-- Killed an enemy
	vfx_killconfirm = {"sfx_mrgotc", "sfx_mrohys", "sfx_mrhaha", "sfx_mrboig"},		-- Killed an enemy
	vfx_1more = {"sfx_mrbrav", "sfx_mrmove", "sfx_mrohya"},		-- Performed 1more
	vfx_crit = {"sfx_mrlets", "sfx_mrtime"},		-- Cut-in for Weakness/Critical Hit
	vfx_aoaask = {"sfx_mritsa"},	-- Ask to All-Out Attack
	vfx_aoado = {"sfx_mrsupr"},		-- Performing All-Out Attack
	vfx_aoarelent = {"sfx_mrnext"},	-- Relenting from All-Out Attack
	vfx_miss = {"sfx_mrdoh", "sfx_mroof"},		-- Missed attack
	vfx_dodge = {"sfx_mrluck", "sfx_mredg1", "sfx_mredg2", "sfx_mrwoah"},	-- Dodged enemy attack
	vfx_win = {"sfx_mrwinn", "sfx_mrnice"},		-- Battle won
	vfx_levelup = {"sfx_mrdund"},	-- Level Up!

	icon = "ICO_MARO",	-- icon for net select and other menus
	hudbust = "H_MARBAR",			-- patch to draw on the stat hud
	hudaoa = "H_MARAOA",	-- patch for all out attack hud
	hudcutin = "MARO_A",	-- cut in
	aoa_quote = "It's-a me\nMario!",

	tip = "Uses special physical attacks with unique properties to overwhelm opponents. Combined with fire and ice skills, he's a force to be reckoned with. Use each moves' action command to deal maximum damage!",
}

VFX_freeslotC("mario")

personaList["mario"] = {
    name = "None",
    arcana = ARCANA_SUN,

    anim_idle = 	{SPR_NULL, A},
	anim_atk = 		{SPR_NULL, A},
	
	weak = ATK_WIND|ATK_ELEC,
	resist = ATK_FIRE|ATK_ICE,

    strength = 12,
    magic = 10,
    endurance = 6,
    luck = 7,
    agility = 10,
	
    skills = {
    {"appeal", 1},
	
	{"multibounce", 3}, {"fire orb", 7},
	{"tarukaja", 11}, {"ice orb", 15},
	{"quake hammer", 18},
	
	{"head rattle", 21}, {"super flame", 25, "fire orb"},
	{"sleepy stomp", 28}, {"super hail", 32, "ice orb"},
	{"power plus", 33, "appeal"}, {"matarukaja", 38, "tarukaja"},
	
	{"magma boots", 41, "multibounce"}, {"power charge", 45, "matarukaja"},
	{"ice smash", 48, "head rattle"}, {"ultra flame", 52, "super flame"},
	{"ultra hail", 63, "super hail"}, {"power plus a", 67, "power plus"},
	
	{"power bounce", 75, "quake hammer"}, {"ultimate flame", 85, "ultra flame"},

    },
	
	//I could make Fire Drive and Tornado Jump skills here, but they have
	//unique animations so I don't feel like it
}

//Testing skills

/*
personaList["mario"].skills = {
    {"appeal", 1},
	
	{"multibounce", 1}, {"fire orb", 1},
	{"tarukaja", 1}, {"ice orb", 1},
	{"quake hammer", 1},
	
	{"head rattle", 1}, {"super flame", 1},
	{"sleepy stomp", 1}, {"super hail", 1},
	{"matarukaja", 1}, //{"power plus", 1},
	
	{"magma boots", 1}, {"power charge", 1},
	{"ice smash", 1}, {"ultra flame", 1},
	{"ultra hail", 1}, {"power plus a", 1},
	
	{"power bounce", 1}, {"ultimate flame", 1},
	
	//Let's see how our fireballs compare to the basic fire and ice skills
	{"agi", 1}, {"agilao", 1}, {"agidyne", 1}, {"trisagion", 1},
	{"bufu", 1}, {"bufula", 1}, {"bufudyne", 1},
	
	//Let's see how our attacks compare to the physical attack skills
	{"skewer", 1}, {"snap", 1},
	{"assault shot", 1}, {"heavy shot", 1}, {"pralaya", 1},
	
	//Funnies
	{"tetrakarn", 1}, {"makarakarn", 1},
	{"infinite endure", 1}, {"last resort", 1},
}
*/

charStats["luigi"] = {
	-- GENERAL
	
	//ChrispyChars are reusable so yay
	overlay = MT_MARIO_OVERALLS,
	overlaythink = function(mo)
		if not (mo and mo.valid) then return end
		
		local target = mo.target
		local player = target and target.valid and target.control
		
		if player and multiplayer
			P_TeleportMove(target,
				target.x + target.momx,
				target.y + target.momy,
				target.z + target.momz)
			DoMarioOveralls(player, target, mo)
			P_TeleportMove(target,
				target.x - target.momx,
				target.y - target.momy,
				target.z - target.momz)
		end
	end,

	name = "Luigi",			-- This is only for bots / enemies
	basehp = 70,			-- base HP for level 1
	basesp = 40,
	persona = "luigi",
	melee_natk = "mario jump",	-- normal melee attack

	wep = "mario_shoes",		-- default weapon.
	weptype = WPT_SHOES|WPT_HAMMER,	-- Equippable weapon type(s)

	atk = 30,	-- attack power of physical attacks
	acc = 85,	-- accuracy of physical attacks
	crit = 5,

	-- ANIMS
	-- Anims are built like this:
	-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame, <"spr2">}
	-- spr2 is optional and must be between quotes, this is to avoid compability issues with older animations

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
	anim_stand_bored =	{SPR_PLAY, A, 1, "SPR2_STND"},	-- standing (rare anim)
	anim_guard = 		{SPR_PLAY, A, 1, "SPR2_LAND"},		-- guarding
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
	anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
	anim_atk =			{SPR_PLAY, A, B, C, D, 2, "SPR2_ROLL"},	-- attacking
	anim_aoa_end =		{SPR_PLAY, A, B, C, D, 2, "SPR2_TWIN"},	-- jumping out of all-out attack
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- is down
	anim_getup =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets up from down
	anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},		-- dies
	anim_revive =		{SPR_PLAY, A, 1, "SPR2_JUMP"},		-- gets revived
	anim_evoker =		{SPR_PLAY, A, 1, "SPR2_STND"},	-- holding evoker to head

	anim_special1 = {SPR_PLAY, D, C, B, A, 2, "SPR2_MLEE"}, -- hammer prep
	anim_special2 = {SPR_PLAY, B, C, D, 1, "SPR2_MLEE"}, -- hammer swing
	anim_special3 = {SPR_PLAY, A, B, C, D, 28, "SPR2_CNT1"},	-- appeal
	anim_special4 = {SPR_PLAY, A, 2, "SPR2_TAL0"}, -- jump start
	anim_special5 = {SPR_PLAY, A, 2, "SPR2_FIRE"}, -- fireball
	anim_special6 = {SPR_PLAY, A, 2, "SPR2_TAL8"}, -- cast

	-- VOICES
	-- Follow this template.
	-- All sounds in there will be *automatically* freeslotted.
	-- For custom characters, call VFX_freeslotC("skinname") OUT OF A THINKFRAME (!)
	-- See Player_Defs.LUA

	vfx_summon = {},	-- Summoning Persona to use a Skill
	vfx_skill = {"sfx_luhaya", "sfx_luheya", "sfx_luhey",
	"sfx_luhol", "sfx_luyah", "sfx_luyaah", "sfx_luyah", "sfx_luyuh"},	-- Used a Skill
	vfx_item = {"sfx_luhuu", "sfx_luwaah", "sfx_luwuho", "sfx_luwaho", "sfx_luhoho"},		-- Used an item
	vfx_hurt = {"sfx_luow", "sfx_luowho", "sfx_luowow", "sfx_luwah", "sfx_luwow", "sfx_luyike"},	-- Sustained damage
	vfx_hurtx = {"sfx_luaaha", "sfx_lufall", "sfx_lulava", "sfx_luwowo"},		-- Sustained heavy damage / Critical hit / Weakness
	vfx_die = {"sfx_ludie1", "sfx_ludie2", "sfx_ludie3", "sfx_lumama"},	-- Death
	vfx_heal = {"sfx_luthnk", "sfx_ludelc", "sfx_luneed", "sfx_luperf"},	-- Healed by teammate
	vfx_healself = {"sfx_ludelc", "sfx_luneed", "sfx_luperf"},	-- Healed self
	vfx_kill = {"sfx_luahah", "sfx_lubye", "sfx_lugotc", "sfx_luohya"},	-- Killed an enemy
	vfx_killconfirm = {"sfx_luahah", "sfx_lubye", "sfx_lugotc", "sfx_luohya"},		-- Killed an enemy
	vfx_1more = {"sfx_lualrg", "sfx_lubrav", "sfx_lumove", "sfx_lucake"},		-- Performed 1more
	vfx_crit = {"sfx_lulets", "sfx_lugowg"},	-- Cut-in for Weakness/Critical Hit
	vfx_aoaask = {"sfx_luread"},	-- Ask to All-Out Attack
	vfx_aoado = {"sfx_lusupr"},		-- Performing All-Out Attack
	vfx_aoarelent = {"sfx_luokie", "sfx_luboo"},	-- Relenting from All-Out Attack
	vfx_miss = {"sfx_luuh", "sfx_lupois"},		-- Missed attack
	vfx_dodge = {"sfx_luluck", "sfx_luedg1", "sfx_luedg2", "sfx_luwoah"},	-- Dodged enemy attack
	vfx_win = {"sfx_luwinr", "sfx_luwon"},		-- Battle won
	vfx_levelup = {"sfx_lunum1"},	-- Level Up!

	icon = "ICO_LUGI",	-- icon for net select and other menus
	hudbust = "H_LUGBAR",			-- patch to draw on the stat hud
	hudaoa = "H_LUGAOA",	-- patch for all out attack hud
	hudcutin = "LUGI_A",	-- cut in
	aoa_quote = "I'm ready!",

	tip = "Luigi shares many of his skills with his brother. However, with a different set of elements and status effects, along with strong magic power and defense, he's a very powerful ally with his own unique strengths.",
}

VFX_freeslotC("luigi")

personaList["luigi"] = {
    name = "None",
    arcana = ARCANA_MOON,

    anim_idle = 	{SPR_NULL, A},
	anim_atk = 		{SPR_NULL, A},
	
	weak = ATK_FIRE|ATK_ICE,
	resist = ATK_WIND|ATK_ELEC,

    strength = 10,
    magic = 12,
    endurance = 10,
    luck = 6,
    agility = 7,
	
    skills = {
    {"appeal", 1},
	
	{"multibounce", 3}, {"thunder hand", 7},
	{"makakaja", 11}, {"wind hand", 15},
	{"quake hammer", 18},
	
	{"piercing blow", 21}, {"super thunder", 25, "thunder hand"},
	{"soft stomp", 28}, {"super wind", 32, "wind hand"},
	{"power plus", 33, "appeal"}, {"mamakakaja", 38, "makakaja"},
	
	{"tornado jump", 41, "multibounce"}, {"mind charge", 45, "mamakakaja"},
	{"electricity smash", 48, "quake hammer"}, {"ultra thunder", 52, "super thunder"},
	{"ultra wind", 63, "super wind"}, {"power plus a", 67, "power plus"},
	
	{"ultimate thunder", 85, "ultra thunder"},

    },
}

//Testing skills

/*personaList["luigi"].skills = {
	{"power plus a", 1}, {"mind charge", 1},
	
	{"thunder hand", 1}, {"super thunder", 1},
	{"ultra thunder", 1}, {"ultimate thunder", 1},
	{"wind hand", 1}, {"super wind", 1},
	{"ultra wind", 1},
	
	//{"soft stomp", 1}, {"tornado jump", 1},
	//{"piercing blow", 1}, {"electricity smash", 1},
}*/

//Always give Mario and Luigi jump/hammer/appeal
local Mario_splitSkills = BTL_splitSkills
BTL_splitSkills = function(v)
	if v.skin == "mario" or v.skin == "luigi"
		table.insert(v.skills, "mario jump")
		table.insert(v.skills, "mario hammer")
	end
	
	Mario_splitSkills(v)
end

//Special junk

weaponsList["mario_shoes"] = {
	name = "Stomping Shoes",
	type = WPT_SHOES,
	atk = 300,
	desc = "Shoes that have\nmet the head of\nmany a Goomba.",
	slot = "mastery 1",
	rarity = 1,
}

mobjinfo[freeslot("MT_MARIO_NICE")] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

local function GetNice(mo, frame)
	local angle = mo.angle
	if server and mo.battlen and server.P_BattleStatus and server.P_BattleStatus[mo.battlen]
		angle = server.P_BattleStatus[mo.battlen].cam.angle
	end
	
	local move = INT8_MAX*FRACUNIT
	local x = P_ReturnThrustX(mo, angle + ANGLE_90, move)
	+ P_ReturnThrustX(mo, angle, move)
	local y = P_ReturnThrustY(mo, angle + ANGLE_90, move)
	+ P_ReturnThrustY(mo, angle, move)
	
	local thok = P_SpawnMobjFromMobj(mo, x, y, 64*FRACUNIT, MT_MARIO_NICE)
	thok.state = S_INVISIBLE
	thok.sprite = SPR_MRPT
	thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
	
	P_SetScale(thok, mo.scale/2)
	thok.destscale = mo.scale*3/2
	
	thok.momz = mo.scale*24
	
	if frame == nil
		playSound(mo.battlen, sfx_mractn)
		thok.frame = H + 1
	else
		playSound(mo.battlen, min(sfx_mrrat1 + frame, sfx_mrrat4))
		thok.frame = H + frame
	end
end

addHook("MobjThinker", function(mobj)
	if not mobj.threshold
		mobj.momz = $ - FRACUNIT*4 * P_MobjFlip(mobj)
	end
	
	if not mobj.reactiontime
		mobj.reactiontime = 1
		mobj.movefactor = mobj.z
	elseif mobj.fuse
		if mobj.fuse <= TICRATE/2
			mobj.spritexscale = $ + FRACUNIT/4
			mobj.spriteyscale = $ - FRACUNIT/4
		end
	elseif mobj.z + mobj.momz <= mobj.movefactor
		mobj.momz = 0
		mobj.z = mobj.movefactor
		
		mobj.threshold = 1
		mobj.fuse = TICRATE
	end
end, MT_MARIO_NICE)

//
//Skills
//

attackDefs["power plus"] = {
	name = "Power Plus Badge",
	type = ATK_PASSIVE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC,
	desc = "Boost Elemental damage by 15%,\nand Jump/Hammer damage by 60%\nLatter won't stack w/ 2 badges.",
	power = 15,
	powerplusbadge = 60,
	passive = PSV_BOOST,
}

attackDefs["power plus a"] = {
	name = "Power Plus Badge A",
	type = ATK_PASSIVE|ATK_FIRE|ATK_ICE|ATK_WIND|ATK_ELEC,
	desc = "Boost Elemental damage by 30%,\nand Jump/Hammer damage by 120%\nLatter won't stack w/ 2 badges.",
	power = 30,
	powerplusbadge = 120,
	passive = PSV_BOOST,
}

attackDefs["appeal"] = {
	name = "Appeal",
	type = ATK_ALMIGHTY,
	target = TGT_CASTER,
	costtype = CST_SP,
	cost = 4,
	power = 40,
	desc = "Fill 40% of the Emerald Drive.",
	nocast = function(targets, n)	-- we can't cast this skill if this function returns true
		local target = targets[n]
		local btl = server.P_BattleStatus[targets[1].battlen]
		if not btl.emeraldpow_max
			BTL_logMessage(targets[1].battlen, "You can't use Emerald Drive in this battle!")
			return true
		elseif btl.emeraldpow >= btl.emeraldpow_max*100
			BTL_logMessage(targets[1].battlen, "You already have max Emerald Drive.")
			return true
		end
	end,
	anim = function(mo, targets, hittargets, timer)
		local cam = server.P_BattleStatus[mo.battlen].cam
		local sector = mo.subsector and mo.subsector.valid and mo.subsector.sector
		
		if timer == 1
			-- move camera instantly
			cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			local cx = mo.x - 256*cos(cam.angle)
			local cy = mo.y - 256*sin(cam.angle)
			local cz = mo.z + FRACUNIT*32

			-- now make it zoom in a little
			CAM_goto(cam, cx, cy, cz, FRACUNIT*32)
			
			/*mo.appealbright = {}
			for sector in sectors.iterate do
				if sector and sector.valid and sector.lightlevel > 64
					mo.appealbright[#sector] = sector.lightlevel
				end
			end*/
		elseif timer == TICRATE/2
			ANIM_set(mo, mo.anim_special3, false)
			playSound(mo.battlen, sfx_mrappl)
			
			mo.appealflags = mo.renderflags
			mo.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
		elseif timer == TICRATE*3/2
			fillEmeraldGauge(mo, 40, true)
			playSound(mo.battlen, sfx_buff2)
			
			mo.renderflags = mo.appealflags
			
			/*for sector in sectors.iterate do
				if sector and sector.valid and mo.appealbright[#sector] != nil
					sector.lightlevel = mo.appealbright[#sector]
				end
			end*/
			return true
		end
		
		if cam.goto and cam.goto[4]
			cam.goto[4] = max($ - FRACUNIT*3/2, FRACUNIT)
		end
		
		/*for sector in sectors.iterate do
			if sector and sector.valid and mo.appealbright[#sector] != nil
				sector.lightlevel = max($ - 2, 64)
			end
		end*/
		
		for i = 1, 2
			local minus = 1
			if i%2 then minus = -$ end
			local angle = cam.angle + ANGLE_90*minus
			local dist = 128*FRACUNIT
			local scale = 4*FRACUNIT
			local z = 192*FRACUNIT
			local momz = -32*FRACUNIT
			
			local thok = P_SpawnMobjFromMobj(mo,P_ReturnThrustX(nil, angle, dist),
			P_ReturnThrustY(nil, angle, dist), z, MT_THOK)
			thok.flags = $|MF_NOCLIPHEIGHT
			thok.skincolor = SKINCOLOR_WHITE
			thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			thok.blendmode = AST_ADD
			thok.scale = scale
			thok.spritexscale = $*2/3
			
			thok.momz = momz
			P_Thrust(thok, angle, -min((timer - TICRATE/3)*FRACUNIT*4, dist/8))
			
			P_TryMove(thok, thok.x + P_ReturnThrustX(nil, cam.angle, mo.radius),
			thok.y + P_ReturnThrustY(nil, cam.angle, mo.radius), true)
		end
	end,
}

//
//Jumps
//

local BUFFMUL = 9
local BUFFDIV = 8
local FIREBUFFMUL = 4
local FIREBUFFDIV = 5
local TIMING = 4

local JUMPTIME = TICRATE*2/3
local MOVETIME = JUMPTIME - TIMING
local STARTINGTIME = TICRATE/2
local mariobutton = 0

local function MarioJumpHUD(v, mo, timer)
	//Wait a second!
	timer = $ - STARTINGTIME
	if timer <= 0 then return end

	if timer > 1 then timer = mo.mariojumptimer or $ end
	local patch = "MRBUTTON1"
	local x = 240
	local y = 100
	
	if timer > JUMPTIME*7/4
		mariobutton = max(min($ - 1, 10), 0)
	else
		mariobutton = $ + 1
	end
	
	local trans = min(max((10 - mariobutton) << FF_TRANSSHIFT, 0), V_90TRANS)
	
	if timer >= MOVETIME - 1 and timer < JUMPTIME and timer > 0
		patch = "MRBUTTON2"
	end
	
	if mariobutton
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT, v.cachePatch(patch), trans)
	end
end

local function MarioJumpAnim(mo, targets, hittargets, timer, condition)
	local btl = server.P_BattleStatus[mo.battlen]
	local cam = btl.cam
	local player = mo.control
	if condition == true then condition = COND_SLEEP end
	mo.flags = $ &~ MF_NOGRAVITY
	
	//Wait a second!
	if timer == 1 then playSound(mo.battlen, sfx_mrattk) end
	timer = $ - STARTINGTIME
	if timer <= 0 then return end
	
	if timer == 1
		mo.mariojumptimer = 0
		mo.mariojumptarget = 1
	end
	mo.mariojumptimer = $ + 1
	timer = mo.mariojumptimer
	
	local target = hittargets[mo.mariojumptarget]

	if timer == 1
		mo.marioactioncommand = false
		ANIM_set(mo, mo.anim_getup, true)
		
		playSound(mo.battlen, sfx_mario6)
		if condition == COND_SLEEP
			playSound(mo.battlen, sfx_hama3)
		elseif condition == COND_BURN
			playSound(mo.battlen, sfx_fire1)
		elseif condition == -1
			playSound(mo.battlen, sfx_debuff)
		elseif condition == -2
			playSound(mo.battlen, sfx_wind2)
			
			for i = 1, 8
				local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
				g.target = mo
				g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
				if i == 1 or i == 8
					g.jizzcolor = true
				end
				if i%2
					g.invertrotation = true
				end
				g.dist = P_RandomRange(45, 90)
				g.tics = 25
			end
		end

		-- fake A_LobShot:
		mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

		local z = mo.z
		local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
		hit.tics = MOVETIME

		local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
		local horizontal = dist / MOVETIME
		local vertical = FixedMul((gravity*2*MOVETIME)*2/3, mo.scale)

		mo.momx = FixedMul(horizontal, cos(mo.angle))
		mo.momy = FixedMul(horizontal, sin(mo.angle))
		mo.momz = vertical
		
		P_TryMove(mo, mo.x + mo.momx*2, mo.y + mo.momy*2, true)

		-- move camera to an interesting spot
		
		if mo.mariojumptarget == 1 //#hittargets <= 1
			local an = target.angle + 45*ANG1
			
			local dist = 384
			if #hittargets > 1 then dist = $*3/2 end

			local cx = target.x + dist*cos(an)
			local cy = target.y + dist*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
		//elseif mo.mariojumptarget == 1
			//We need a camera for this...
		end
		
	//Deal damage
	elseif timer == JUMPTIME or (mo.marioactioncommand and timer == JUMPTIME*2)
		ANIM_set(mo, mo.anim_getup, true)
		local missed = true
		
		if target.damagestate == DMG_MISS
		or target.damagestate == DMG_BLOCK
		or target.damagestate == DMG_DRAIN
		or btl.dmg_hits[target.dmg_index][1] == "miss"
			damageObject(target)
		else
			//Buff the attack using Power Plus Badge and Power Charge
			if type(btl.dmg_hits[target.dmg_index][1]) == "number"
				//Basic buff
				btl.dmg_hits[target.dmg_index][1] = $*BUFFMUL/BUFFDIV
				
				//Power Plus Badge
				local amp = 0
				for i = 1, #mo.passiveskills do
					local s = attackDefs[mo.passiveskills[i]]
					if s.passive == PSV_BOOST and s.powerplusbadge
						amp = max($, s.powerplusbadge)
					end
				end
				btl.dmg_hits[target.dmg_index][1] = $ + $*amp/100
				
				//Power Charge
				if mo.powercharge
					btl.dmg_hits[target.dmg_index][1] = $*30/12
				end
			end
			
			btl.dmg_hits[target.dmg_index][1] = $/2
			damageObject(target)
			missed = false
			
			if condition and timer == JUMPTIME*2
				if condition > 0
					inflictStatus(target, condition)
					if condition == COND_SLEEP
						playSound(mo.battlen, sfx_mrslep)
						
						for i = 1, 20
							local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
							thok.flags = MF_NOBLOCKMAP
							thok.color = SKINCOLOR_PURPLE
							if i%2 then thok.color = SKINCOLOR_BLACK end
							thok.frame = A
							thok.tics = 35
							thok.scale = FRACUNIT/2
							thok.scalespeed = FRACUNIT/32
							thok.destscale = 1
							thok.momz = P_RandomRange(5, 10)*FRACUNIT
							thok.momx = P_RandomRange(-6, 6)*FRACUNIT
							thok.momy = P_RandomRange(-6, 6)*FRACUNIT
						end
					elseif condition == COND_BURN
						//DoExplosion(target)
						playSound(mo.battlen, sfx_fire2)
						for i = 1, 10
							local b = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*32, MT_BOOMPARTICLE)
							b.momx = P_RandomRange(-32, 32)<<FRACBITS
							b.momy = P_RandomRange(-32, 32)<<FRACBITS
							b.momz = P_RandomRange(0, 16)<<FRACBITS
							b.fuse = TICRATE*6
						end
					end
					
				//Soft and Garuverse
				else
					if condition == -2
						startField(target, FLD_GARUVERSE, 3)
					else
						buffStat(target, "def", -BUFFSTEP*3)	-- negative values lower a stat
						playSound(mo.battlen, sfx_absorb)
						local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
						dbuff.state = S_DBUFF1
						dbuff.color = SKINCOLOR_LAVENDER
						dbuff.scale = FRACUNIT*5/2
						
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.sprite = SPR_DBUF
						orb.frame = A|TR_TRANS30
						orb.scale = FRACUNIT*2
						orb.scalespeed = FRACUNIT/16
						orb.destscale = FRACUNIT/6
						orb.tics = TICRATE
						orb.color = SKINCOLOR_LAVENDER
					end
					
					for i = 1, 3
						local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						s.scale = FRACUNIT/4
						s.sprite = SPR_SLAS
						s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
						s.destscale = FRACUNIT*9
						s.scalespeed = FRACUNIT
						if condition != -2
							s.color = SKINCOLOR_LAVENDER
							s.colorized = true
							s.frame = $ &~ FF_TRANSMASK
						end
					end
				end
			end
		end
		
		if not missed
			playSound(mo.battlen, sfx_mrhit)
			MarioDoStars(mo)
			
			localquake(mo.battlen, FRACUNIT*20, 10)
			//createSplat(mo)
			
			P_InstaThrust(mo, 0, 0)
			mo.momz = FixedMul((gravity*4*MOVETIME)/2, mo.scale) - gravity*4
			
			if mo.mariojumptarget >= #hittargets and #hittargets > 1
				GetNice(mo, 3)
				MarioDoHit(mo, true, 3)
			elseif mo.marioactioncommand and #hittargets > 1
				if mo.mariojumptarget > #hittargets*2/3
					GetNice(mo, 2)
					MarioDoHit(mo, false, 2)
				elseif mo.mariojumptarget > #hittargets/3
					GetNice(mo, 1)
					MarioDoHit(mo, false, 1)
				else
					GetNice(mo, 0)
					MarioDoHit(mo)
				end
			elseif timer == JUMPTIME
				if mo.marioactioncommand
					GetNice(mo)
				end
				MarioDoHit(mo, false, 0)
			else
				MarioDoHit(mo, true)
			end
		end
		
		if missed
			VFX_Play(mo, VFX_MISS)
			if timer == JUMPTIME
				mo.marioactioncommand = false
			end
		elseif not target.hp and #hittargets <= 1
		and timer == JUMPTIME
			mo.marioactioncommand = false
			P_InstaThrust(mo, mo.angle, -8*mo.scale)
		elseif mo.marioactioncommand and timer == JUMPTIME
			if mo.mariojumptarget < #hittargets and #hittargets > 1
				mo.mariojumptarget = $ + 1
				mo.mariojumptimer = 0
				mo.marioactioncommand = false
			else
				ANIM_set(mo, mo.anim_aoa_end, true)
			end
		else
			P_InstaThrust(mo, mo.angle, -8*mo.scale)
		end
		
		mo.z = mo.floorz + mo.height*2
		
	//Short time period
	elseif (timer < JUMPTIME and timer >= JUMPTIME - TIMING)
	or (timer < JUMPTIME*2 and timer >= JUMPTIME*2 - TIMING and mo.marioactioncommand)
		ANIM_set(mo, mo.anim_special4, true)
		mo.rollangle = 0
		
		target.mariosquish = TIMING
		
		if not mo.marioactioncommand
		and (mo.mariojumptarget < #hittargets or #hittargets <= 1)
		and (not player or player.realmo.P_inputs[BT_JUMP] == 1
		or player.realmo.P_inputs[BT_JUMP] == 2)
			mo.marioactioncommand = true
		end
		
		P_InstaThrust(mo, 0, 0)
		mo.momz = 0
		
		mo.z = mo.floorz + mo.height*2
		
	//End
	elseif (timer >= JUMPTIME*2 and not mo.marioactioncommand)
	or timer > JUMPTIME*3
		ANIM_set(mo, anim_stand, true)
		mo.rollangle = 0
		return true
		
	//Second jump's flip
	elseif (mo.marioactioncommand and timer < JUMPTIME*2)
	or mo.mariojumptarget > 1
		mo.rollangle = $ - ANGLE_22h
		mo.momz = $ - gravity*2
		
		if condition and condition != -2 and timer < JUMPTIME
			local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP
			thok.momz = P_RandomRange(5, 10)*FRACUNIT
			thok.momx = P_RandomRange(-6, 6)*FRACUNIT
			thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			
			if condition == COND_BURN
				thok.state = S_QUICKBOOM1
			else
				thok.color = SKINCOLOR_PURPLE
				if condition == -1
					thok.color = SKINCOLOR_LAVENDER
				elseif timer&1
					thok.color = SKINCOLOR_BLACK
				end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
			end
		end
		
	//Extra gravity
	else
		mo.momz = $ - gravity
		
		if condition and condition != -2 and timer < JUMPTIME
			local thok = P_SpawnMobj(mo.x + P_RandomRange(-40, 40)*FRACUNIT, mo.y + P_RandomRange(-40, 40)*FRACUNIT, mo.z, MT_DUMMY)
			thok.flags = MF_NOBLOCKMAP
			thok.momz = P_RandomRange(5, 10)*FRACUNIT
			thok.momx = P_RandomRange(-6, 6)*FRACUNIT
			thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			
			if condition == COND_BURN
				thok.state = S_QUICKBOOM1
			else
				thok.color = SKINCOLOR_PURPLE
				if condition == -1
					thok.color = SKINCOLOR_LAVENDER
				elseif timer&1
					thok.color = SKINCOLOR_BLACK
				end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
			end
		end
	end
	
	if P_IsObjectOnGround(mo) and not mo.momz
		ANIM_set(mo, anim_stand, true)
		mo.rollangle = 0
	end
	
	//Squishy
	for id,t in pairs(hittargets) do
		target = t
		if target.mariosquish
			if target.mariosquish > 0
				target.mariosquish = $ - 1
			else
				target.mariosquish = $ + 1
			end
			
			local factor = target.mariosquish*FRACUNIT/8
			if not target.mariosize
				target.spritexscale = FRACUNIT
				target.spriteyscale = FRACUNIT
			end
			target.spritexscale = $ + FixedMul($, factor)
			target.spriteyscale = $ - FixedMul($, factor)
		end
	end
end
		
attackDefs["mario jump"] = {
	name = "Jump",
	type = ATK_PIERCE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ENEMY,
	
	costtype = CST_HP,
	cost = 0,
	
	desc = "A jump that uses weapon stats.\nIt's the same as your basic attack!\nPress A stomping the enemy.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = MarioJumpAnim,
}

attackDefs["multibounce"] = {
	name = "Multibounce",
	type = ATK_PIERCE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ALLENEMIES,
	
	costtype = CST_HPPERCENT,
	cost = 8,
	
	desc = "A jump that uses weapon stats.\nPress A stomping an enemy\nto move to the next one!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = MarioJumpAnim,
}

attackDefs["sleepy stomp"] = {
	name = "Sleepy Stomp",
	type = ATK_PIERCE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 10,
	
	desc = "A jump that uses weapon stats.\nThe 2nd jump inflicts sleep.\nPress A stomping the enemy.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = function(mo, targets, hittargets, timer)
		if timer == 1
			mo.dothesleepy = not hittargets[1].status_condition
		end
		
		return MarioJumpAnim(mo, targets, hittargets, timer, mo.dothesleepy)
	end,
}

attackDefs["magma boots"] = {
	name = "Magma Boots",
	type = ATK_FIRE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 13,
	
	desc = "A jump that uses weapon stats.\nThe 2nd jump inflicts burn.\nPress A stomping the enemy.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioJumpAnim(mo, targets, hittargets, timer, COND_BURN)
	end,
}

attackDefs["soft stomp"] = {
	name = "Soft Stomp",
	type = ATK_PIERCE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 10,
	
	desc = "A jump that uses weapon stats.\nThe 2nd jump minimizes defense.\nPress A stomping the enemy.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioJumpAnim(mo, targets, hittargets, timer, -1)
	end,
}

attackDefs["tornado jump"] = {
	name = "Tornado Jump",
	type = ATK_WIND,
	accuracy = 95,
	critical = 4, -- was 7
	hits = 2,
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 13,
	
	desc = "A jump that uses weapon stats.\nThe 2nd jump inflicts Garuverse for 3 turns.\nPress A stomping the enemy.",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioJumpAnim(mo, targets, hittargets, timer, -2)
	end,
}

//
//Power Bounce (because yes this needs its own function)
//

local MULTINICES = 3

attackDefs["power bounce"] = {
	name = "Power bounce",
	type = ATK_PIERCE,
	accuracy = 95,
	critical = 4, -- was 7
	hits = UINT8_MAX,
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 18,
	
	desc = "A jump that uses weapon stats.\nLasts for as long as you can\nkeep up the action command!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioJumpHUD,
	anim = function(mo, targets, hittargets, timer)
		local btl = server.P_BattleStatus[mo.battlen]
		local cam = btl.cam
		local player = mo.control
		mo.flags = $ &~ MF_NOGRAVITY
		
		//Wait a second!
		if timer == 1 then playSound(mo.battlen, sfx_mrattk) end
		timer = $ - STARTINGTIME
		if timer <= 0 then return end
		
		if timer == 1
			mo.mariojumptimer = 0
			mo.mariojumptarget = 1
		end
		mo.mariojumptimer = $ + 1
		timer = mo.mariojumptimer
		
		local target = hittargets[1]
		local newtiming = max(TIMING + 1 - mo.mariojumptarget/MULTINICES, 1)

		if timer == 1
			mo.marioactioncommand = false
			ANIM_set(mo, mo.anim_getup, true)
			
			playSound(mo.battlen, sfx_mario6)

			-- fake A_LobShot:
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

			local z = mo.z
			local hit = P_SpawnMobj(target.x & (64*FRACUNIT -1), target.y & (64*FRACUNIT -1), target.subsector.sector.floorheight, MT_NULL)
			hit.tics = MOVETIME

			local dist = P_AproxDistance(target.x - mo.x, target.y - mo.y)
			local horizontal = dist / MOVETIME
			local vertical = FixedMul((gravity*2*MOVETIME)*2/3, mo.scale)

			mo.momx = FixedMul(horizontal, cos(mo.angle))
			mo.momy = FixedMul(horizontal, sin(mo.angle))
			mo.momz = vertical
			
			P_TryMove(mo, mo.x + mo.momx*2, mo.y + mo.momy*2, true)

			-- move camera to an interesting spot
			
			local an = target.angle + 45*ANG1
				
			local dist = 384

			local cx = target.x + dist*cos(an)
			local cy = target.y + dist*sin(an)

			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, server.P_BattleStatus[mo.battlen].cam.z, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y), ANG1*4)
			
		//Deal damage
		elseif timer == JUMPTIME or (mo.marioactioncommand and timer == JUMPTIME*2)
			ANIM_set(mo, mo.anim_getup, true)
			local missed = true
			local tutorial = SAVE_localtable.tutorial
			
			if target.damagestate == DMG_MISS
			or target.damagestate == DMG_BLOCK
			or target.damagestate == DMG_DRAIN
			or not (target.dmg_index and btl and btl.dmg_hits
			and btl.dmg_hits[target.dmg_index]
			and btl.dmg_hits[target.dmg_index][1])
			or btl.dmg_hits[target.dmg_index][1] == "miss"
				damageObject(target)
			else
				//Buff the attack using Power Plus Badge and Power Charge
				if type(btl.dmg_hits[target.dmg_index][1]) == "number"
					//Basic buff
					btl.dmg_hits[target.dmg_index][1] = $*BUFFMUL/BUFFDIV
					
					//Power Plus Badge
					local amp = 0
					for i = 1, #mo.passiveskills do
						local s = attackDefs[mo.passiveskills[i]]
						if s.passive == PSV_BOOST and s.powerplusbadge
							amp = max($, s.powerplusbadge)
						end
					end
					btl.dmg_hits[target.dmg_index][1] = $ + $*amp/100
					
					//Power Charge
					if mo.powercharge
						btl.dmg_hits[target.dmg_index][1] = $*30/12
					end
				end
			
				btl.dmg_hits[target.dmg_index][1] = $/4/max(mo.mariojumptarget/(MULTINICES+1), 1)
				damageObject(target)
				missed = false
			end
			
			if not missed
				playSound(mo.battlen, sfx_mrhit)
				MarioDoStars(mo)
				
				localquake(mo.battlen, FRACUNIT*20, 10)
				//createSplat(mo)
				
				P_InstaThrust(mo, 0, 0)
				mo.momz = FixedMul((gravity*4*MOVETIME)/2, mo.scale) - gravity*4
			end
			
			if missed
				VFX_Play(mo, VFX_MISS)
				if timer == JUMPTIME
					mo.marioactioncommand = false
				end
			elseif not target.hp and #hittargets <= 1 and timer == JUMPTIME
				mo.marioactioncommand = false
				P_InstaThrust(mo, mo.angle, -8*mo.scale)
			elseif mo.marioactioncommand and timer == JUMPTIME
				local nice = min((mo.mariojumptarget - 1)/MULTINICES, 3)
				GetNice(mo, nice)
				MarioDoHit(mo, nice >= 3, nice)
				
				mo.mariojumptarget = $ + 1
				mo.mariojumptimer = 0
				mo.marioactioncommand = false
			else
				P_InstaThrust(mo, mo.angle, -8*mo.scale)
			end
			
			mo.z = mo.floorz + mo.height*2
			
		//Short time period
		elseif (timer < JUMPTIME and timer >= JUMPTIME - newtiming)
		or (timer < JUMPTIME*2 and timer >= JUMPTIME*2 - newtiming and mo.marioactioncommand)
			ANIM_set(mo, mo.anim_special4, true)
			mo.rollangle = 0
			
			target.mariosquish = TIMING
			
			if not mo.marioactioncommand
			and ((not player and mo.mariojumptarget <= MULTINICES*3 + 1)
			or (player and (player.realmo.P_inputs[BT_JUMP] == 1
			or player.realmo.P_inputs[BT_JUMP] == 2)))
				mo.marioactioncommand = true
			end
			
			P_InstaThrust(mo, 0, 0)
			mo.momz = 0
			
			mo.z = mo.floorz + mo.height*2
			
		//End
		elseif (timer >= JUMPTIME*2 and not mo.marioactioncommand)
		or timer > JUMPTIME*3
			ANIM_set(mo, anim_stand, true)
			mo.rollangle = 0
			return true
			
		//Second jump's flip
		elseif mo.mariojumptarget > 1
			mo.rollangle = $ - ANGLE_22h
			mo.momz = $ - gravity*2
			
		//Extra gravity
		else
			mo.momz = $ - gravity
		end
		
		if P_IsObjectOnGround(mo) and not mo.momz
			ANIM_set(mo, anim_stand, true)
			mo.rollangle = 0
		end
		
		//Squishy
		for id,t in pairs(hittargets) do
			target = t
			if target.mariosquish
				if target.mariosquish > 0
					target.mariosquish = $ - 1
				else
					target.mariosquish = $ + 1
				end
				
				local factor = target.mariosquish*FRACUNIT/8
				if not target.mariosize
					target.spritexscale = FRACUNIT
					target.spriteyscale = FRACUNIT
				end
				target.spritexscale = $ + FixedMul($, factor)
				target.spriteyscale = $ - FixedMul($, factor)
			end
		end
	end,
}

//
//Hammer
//

local HAMLIGHTS = 4
local HAMTIME = TICRATE/2
local TOTALHAM = HAMLIGHTS*HAMTIME

local function MarioHammerHUD(v, mo, timer)
	//Wait a second!
	timer = $ - STARTINGTIME
	
	if timer <= 1 then return end
	local patch = "MRHAM"..(mo.reachedtarget/HAMTIME + 1)
	local patch2 = "MRSTICK1"
	local x = 240
	local y = 100
	local y2 = -24
	
	if mo.swingtime
		mariobutton = max(min($ - 1, 10), 0)
	else
		mariobutton = $ + 1
		if mo.reachedtarget and mo.reachedtarget < TOTALHAM
			patch2 = "MRSTICK2"
		end
	end
	
	local trans = min(max((10 - mariobutton) << FF_TRANSSHIFT, 0), V_90TRANS)
	
	if mariobutton
		v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT, v.cachePatch(patch), trans)
		v.drawScaled(x*FRACUNIT, (y+y2)*FRACUNIT, FRACUNIT, v.cachePatch(patch2), trans)
	end
end

local function MarioHammerAnim(mo, targets, hittargets, timer, condition)
	local target = targets[1]
	local atarget = hittargets[1]
	local btl = server.P_BattleStatus[mo.battlen]
	local cam = btl.cam
	local player = mo.control
	mo.flags = $ &~ MF_NOGRAVITY
	
	//Wait a second!
	if timer == 1 then playSound(mo.battlen, sfx_mrattk) end
	timer = $ - STARTINGTIME
	if timer <= 0 then return end
	
	if timer == 1
		ANIM_set(mo, mo.anim_move, true)
		mo.reachedtarget = 0	-- yeah we can use variables here that you like it or not :^)
		mo.swingtimer = 0
		mo.marioactioncommand = false
		
		if #hittargets <= 1
			local dist = R_PointToDist2(mo.x, mo.y, target.x, target.y)
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			P_InstaThrust(mo, mo.angle, dist/16)
			
			local cx = target.x + UINT8_MAX*cos(target.angle + ANG1*20)
			local cy = target.y + UINT8_MAX*sin(target.angle + ANG1*20)
			CAM_goto(cam, cx, cy, target.z + FRACUNIT*50, 50*FRACUNIT)
			CAM_angle(cam, R_PointToAngle2(cx, cy, target.x, target.y))
		end
	end
	
	if mo.swingtimer
		if mo.swingtimer == 1
			playSound(mo.battlen, sfx_mrhmr1)
			playSound(mo.battlen, sfx_mrhmr1)
			ANIM_set(mo, mo.anim_special2, false)
			
			if #hittargets > 1
				mo.momz = gravity*14
			end
		elseif (mo.swingtimer == 4 and #hittargets <= 1)
		or (mo.swingtimer == TICRATE/2 and #hittargets > 1)
			local miss = true
			playSound(mo.battlen, sfx_mrhmr2)
			playSound(mo.battlen, sfx_mrhmr2)
			
			//Hit the enemies
			for id,t in pairs(hittargets) do
				atarget = t
				if not (atarget.dmg_index and btl and btl.dmg_hits
				and btl.dmg_hits[atarget.dmg_index]
				and btl.dmg_hits[atarget.dmg_index][1])
					continue
				elseif atarget.damagestate == DMG_MISS
				or atarget.damagestate == DMG_BLOCK
				or atarget.damagestate == DMG_DRAIN
				or btl.dmg_hits[atarget.dmg_index][1] == "miss"
					VFX_Play(mo, VFX_MISS)
				elseif mo.marioactioncommand
					atarget.mariosquish = TICRATE/3
					miss = false
				else
					btl.dmg_hits[atarget.dmg_index][1] = $/2
					miss = false
				end
				
				//Buff the attack using Power Plus Badge and Power Charge
				if type(btl.dmg_hits[atarget.dmg_index][1]) == "number"
					//Basic buff
					btl.dmg_hits[atarget.dmg_index][1] = $*BUFFMUL/BUFFDIV
					
					//Power Plus Badge
					local amp = 0
					for i = 1, #mo.passiveskills do
						local s = attackDefs[mo.passiveskills[i]]
						if s.passive == PSV_BOOST and s.powerplusbadge
							amp = max($, s.powerplusbadge)
						end
					end
					btl.dmg_hits[atarget.dmg_index][1] = $ + $*amp/100
					
					//Power Charge
					if mo.powercharge
						btl.dmg_hits[atarget.dmg_index][1] = $*30/12
					end
				end
				
				//Set Zioverse before damage so it damages others with Zioverse
				if condition == COND_SHOCK
					startField(atarget, FLD_ZIOVERSE, 3)
				end
				damageObject(atarget)
				
				if not miss 
					MarioDoStars(atarget)
					if mo.marioactioncommand
						MarioDoHit(atarget, true)
						
						//Elemental effects
						if condition
							if condition == COND_SHOCK
								//startField(atarget, FLD_ZIOVERSE, 3)
							elseif condition > 0
								inflictStatus(atarget, condition)
							end
							
							if condition == COND_DIZZY
								S_StartSound(target, sfx_kc4b)
								
								local d = P_SpawnMobj(atarget.x, atarget.y, atarget.z + FRACUNIT*64, MT_THOK)
								d.state = S_HOWL1
								d.color = SKINCOLOR_AETHER
								d.angle = atarget.angle + ANG1*90
								d.scale = atarget.scale*2
								d.destscale = atarget.scale*7
								d.scalespeed = FRACUNIT/4
								P_InstaThrust(d, atarget.angle, FRACUNIT*32)
							elseif condition == COND_FREEZE
								playSound(mo.battlen, sfx_bufu4)
							
								for i=1,20
								local bb = P_SpawnMobj(atarget.x, atarget.y, atarget.z + FRACUNIT*20, MT_BUFU_PARTICLE)
									bb.state, bb.scale = i%2 and S_BUFU_PARTICLE_B or S_BUFU_PARTICLE_A, mo.scale
									bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
								end
							elseif condition == COND_SHOCK
								local z1 = P_SpawnMobj(atarget.x, atarget.y, atarget.floorz, MT_DUMMY)
								z1.state, z1.scale, z1.color = S_LZIO11, atarget.scale*15/4, SKINCOLOR_TEAL
								z1.destscale = atarget.scale*3/2
								local z2 = P_SpawnMobj(atarget.x, atarget.y, atarget.floorz, MT_DUMMY)
								z2.state, z2.scale, z2.color = S_LZIO21, atarget.scale*15/4, SKINCOLOR_SKY
								z2.destscale = atarget.scale*3/2

								playSound(mo.battlen, sfx_zio2)
								
							elseif condition == -1 //Pierce
								for i = 1, 16
									local boom = P_SpawnMobj(atarget.x + P_RandomRange(-20, 20)*FRACUNIT, atarget.y + P_RandomRange(-20, 20)*FRACUNIT, atarget.z + 10*FRACUNIT, MT_DUMMY)
									boom.state = S_CQUICKBOOM1
									boom.color = SKINCOLOR_WHITE
									boom.momx = P_RandomRange(-20, 20)*FRACUNIT
									boom.momy = P_RandomRange(-20, 20)*FRACUNIT
									boom.momz = P_RandomRange(-20, 20)*FRACUNIT
									boom.scale = FRACUNIT*3/2
								end
								playSound(mo.battlen, sfx_megi6)
							end
						end
					else
						MarioDoHit(atarget, false, 0)
					end
				end
			end

			if not miss
				playSound(mo.battlen, sfx_mrhhit)
				if mo.marioactioncommand
					GetNice(mo, 1)
					localquake(mo.battlen, FRACUNIT*30, 8)
					playSound(mo.battlen, #hittargets <= 1 and sfx_pstop or sfx_megi5)
				elseif #hittargets > 1
					localquake(mo.battlen, FRACUNIT*30, 8)
					playSound(mo.battlen, sfx_pstop)
				end
			end
		elseif (mo.swingtimer >= TICRATE/2 and #hittargets <= 1)
		or mo.swingtimer >= TICRATE
			return true
		end
		mo.swingtimer = $ + 1
		
		if #hittargets > 1
			mo.momz = $ - gravity
		end
	elseif mo.reachedtarget
	or R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*100
	or FixedHypot(mo.momx, mo.momy) < FRACUNIT*10	-- in case of bugs
	or #hittargets > 1
		P_InstaThrust(mo, 0, 0)
		mo.reachedtarget = $+1
		
		if mo.reachedtarget == 1
			ANIM_set(mo, mo.anim_special1, false)
			if mo.skin == "mario"
				playSound(mo.battlen, sfx_mrhold)
			elseif mo.skin == "luigi"
				playSound(mo.battlen, sfx_luhold)
			end
			
			if condition == COND_DIZZY
				playSound(mo.battlen, sfx_kc5d)
			elseif condition == COND_FREEZE
				playSound(mo.battlen, sfx_karin)
			elseif condition == COND_SHOCK
				playSound(mo.battlen, sfx_zio4)
			elseif condition == -1 //Pierce
				playSound(mo.battlen, sfx_hama3)
			end
		end
		
		if not (mo.reachedtarget % HAMTIME)
			if mo.reachedtarget >= TOTALHAM
				playSound(mo.battlen, sfx_mrbep2)
			else
				playSound(mo.battlen, sfx_mrbep1)
			end
		end
		
		if mo.reachedtarget > 6
			mo.spritexoffset = P_SignedRandom()*FRACUNIT/INT8_MAX
			mo.spriteyoffset = P_SignedRandom()*FRACUNIT/INT8_MAX
			
			//Elemental effects
			if condition
				local s = P_SpawnMobj(mo.x - P_ReturnThrustX(mo, mo.angle, mo.radius*3) + P_RandomRange(-16, 16)*FRACUNIT,
				mo.y - P_ReturnThrustY(mo, mo.angle, mo.radius*3) + P_RandomRange(-16, 16)*FRACUNIT,
				mo.z + mo.height*3/2, MT_DUMMY)
				
				if condition == COND_DIZZY
					s.sprite = SPR_STUN
					s.frame = P_RandomRange(0, 2)|FF_FULLBRIGHT|FF_TRANS30
					s.color = P_RandomRange(0,1) and SKINCOLOR_LAVENDER or SKINCOLOR_ORANGE
					s.scale = P_RandomRange(FRACUNIT/2, FRACUNIT)
					s.destscale = 1
					s.tics = TICRATE*3/2
				elseif condition == COND_FREEZE
					s.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					s.state, s.scale, s.angle = S_BUFUDYNE_DUST1, FRACUNIT, 0
					s.scale = $/2
					s.destscale = FRACUNIT*9/8
					s.scalespeed = FRACUNIT/36
				elseif condition == COND_SHOCK
					s.sprite = SPR_DELK
					s.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
					s.scale = $/4
					s.destscale = FRACUNIT
					s.scalespeed = FRACUNIT/16
					s.tics = TICRATE/8
					s.color = SKINCOLOR_SKY
				else
					s.flags = $|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					s.state, s.scale, s.angle = S_CQUICKBOOM1, FRACUNIT, 0
					s.color = SKINCOLOR_WHITE
					s.scale = $/2
					s.destscale = FRACUNIT*9/8
					s.scalespeed = FRACUNIT/36
				end
				s.momz = P_RandomRange(2, 5)*FRACUNIT
			end
		end
		
		if (mo.reachedtarget > HAMTIME and ((player and player.cmd.sidemove >= 0)
		or (not player and mo.reachedtarget == TOTALHAM)))
		or mo.reachedtarget > TOTALHAM + TIMING*2
			mo.swingtimer = 1
			mo.spritexoffset = 0
			mo.spriteyoffset = 0
			
			if mo.reachedtarget >= TOTALHAM
			and mo.reachedtarget <= TOTALHAM + TIMING*3/2
				mo.marioactioncommand = true
			end
		end
	else
		mo.friction = FRACUNIT
	end
	
	//Squishy
	for id,t in pairs(hittargets) do
		target = t
		if target.mariosquish
			if target.mariosquish > 0
				target.mariosquish = $ - 1
			else
				target.mariosquish = $ + 1
			end
			
			local factor = target.mariosquish*FRACUNIT/16
			if not target.mariosize
				target.spritexscale = FRACUNIT
				target.spriteyscale = FRACUNIT
			end
			target.spritexscale = $ + FixedMul($, factor)
			target.spriteyscale = $ - FixedMul($, factor)
		end
	end
end

attackDefs["mario hammer"] = {
	name = "Hammer",
	type = ATK_STRIKE,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ENEMY,
	
	costtype = CST_HP,
	cost = 0,
	
	desc = "A hammer swing that uses weapon stats.\nIt has no special properties.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = MarioHammerAnim,
}

attackDefs["quake hammer"] = {
	name = "Quake Hammer",
	type = ATK_STRIKE,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ALLENEMIES,
	
	costtype = CST_HPPERCENT,
	cost = 10,
	
	desc = "A hammer swing that uses weapon stats.\nHits all enemies.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = MarioHammerAnim,
}

attackDefs["head rattle"] = {
	name = "Head Rattle",
	type = ATK_STRIKE,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 10,
	
	desc = "A hammer swing that uses weapon stats.\nInflicts dizziness on a successful hit.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioHammerAnim(mo, targets, hittargets, timer, COND_DIZZY)
	end,
}

attackDefs["ice smash"] = {
	name = "Ice Smash",
	type = ATK_ICE,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 13,
	
	desc = "A hammer swing that uses weapon stats.\nInflicts freeze on a successful hit.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioHammerAnim(mo, targets, hittargets, timer, COND_FREEZE)
	end,
}

attackDefs["piercing blow"] = {
	name = "Piercing Blow",
	type = ATK_ALMIGHTY,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 10,
	
	desc = "A hammer swing that uses weapon stats.\nBypasses weaknesses and destroys barriers.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioHammerAnim(mo, targets, hittargets, timer, -1)
	end,
}

attackDefs["electricity smash"] = {
	name = "Electricity Smash",
	type = ATK_ELEC,
	accuracy = 95,
	critical = 7, -- was 7
	
	target = TGT_ENEMY,
	
	costtype = CST_HPPERCENT,
	cost = 13,
	
	desc = "A hammer swing that uses weapon stats.\nInflicts Zioverse for 3 turns on a successful hit.\nHold left, release when the star indicator lights!",
	anim_norepel = true,	-- do not bounce back our ANIMATION
	physical = true,	-- don't play the summoning anim for phys attacks, duh
	
	hudfunc = MarioHammerHUD,
	anim = function(mo, targets, hittargets, timer)
		return MarioHammerAnim(mo, targets, hittargets, timer, COND_SHOCK)
	end,
}

//
//Fireballs
//

local STARTTIME = TICRATE*3/2
local FIRETIMING = 7
states[freeslot("S_MARIO_CAST1")] = {SPR_MRPT, D|FF_TRANS80, 2, nil, 0, 0, freeslot("S_MARIO_CAST2")}
states[S_MARIO_CAST2] = {SPR_MRPT, E|FF_TRANS60, 2, nil, 0, 0, freeslot("S_MARIO_CAST3")}
states[S_MARIO_CAST3] = {SPR_MRPT, F|FF_TRANS40, 2, nil, 0, 0, freeslot("S_MARIO_CAST4")}
states[S_MARIO_CAST4] = {SPR_MRPT, G|FF_TRANS20, 2, nil, 0, 0, freeslot("S_MARIO_CAST")}
states[S_MARIO_CAST] = {SPR_MRPT, D|FF_ANIMATE, 8, nil, 3, 2, S_MARIO_CAST}

local function FireOrbHUD(v, mo, timer)
	if timer >= STARTTIME then return end
	
	v.drawScaled(160*FRACUNIT, 50*FRACUNIT, FRACUNIT, v.cachePatch("MRBANNER"))
	v.drawString(88, 36, string.sub("Press 'B' repeatedly!", 1, timer))
end

local ORBFIRES = 12

local function FireOrbAnim(mo, targets, hittargets, timer, firetype, size, fires)
	fires = $ or ORBFIRES
	local STOPTIME = FIRETIMING*fires + STARTTIME

	local player = mo.control
	
	if timer == 1
		mo.marioactioncommand = true
		mo.mariofirehit = 0
		mo.mariofireballs = {}
		
		ANIM_set(mo, mo.anim_special6, true)
		
		local thok = P_SpawnMobjFromMobj(mo,
		P_ReturnThrustX(nil, mo.angle, -FRACUNIT),
		P_ReturnThrustY(nil, mo.angle, -FRACUNIT),
		player and player.height/2 or FixedDiv(mo.height/2, mo.scale), MT_THOK)
		thok.state = S_MARIO_CAST1
		thok.fuse = TICRATE
		
		playSound(mo.battlen, sfx_mrcast)
	end
	
	local btl = server.P_BattleStatus[mo.battlen]
	local target = hittargets[(mo.mariofirehit % #hittargets) + 1]
	mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y, 0,0)
	
	local firetimer = timer - STARTTIME
	if firetimer > 0 and timer <= STOPTIME
		local balltimer = firetimer%FIRETIMING
		ANIM_set(mo, mo.anim_special5, true)
		
		//Hit the button!
		if balltimer
			if not player or player.realmo.P_inputs[BT_SPIN] == 1
			or player.realmo.P_inputs[BT_CUSTOM1] == 1
				mo.marioactioncommand = true
			end
			
		//Throw ball
		elseif mo.marioactioncommand
			playSound(mo.battlen, firetype == 2 and sfx_mriceb or sfx_mrorb)
			mo.marioactioncommand = false
			
			if firetype then mobjinfo[MT_MARIO_FIREBALL].raisestate = firetype
			else mobjinfo[MT_MARIO_FIREBALL].raisestate = 0 end
			
			local fireball = P_SPMAngle(mo, MT_MARIO_FIREBALL, mo.angle)
			fireball.sprite = SPR_NULL
			fireball.tics = 1
			if target.hp
				fireball.fuse = TICRATE/2
			end
				
			if size
				P_SetScale(fireball, FixedMul(fireball.scale, size))
				fireball.destscale = FixedMul($, size)
			end
				
			fireball.hnext = target
			fireball.nice = mo.mariofirehit/(fires/4)
			table.insert(mo.mariofireballs, fireball)
			
			mo.mariofirehit = $ + 1
			if mo.mariofirehit == fires/4
				GetNice(mo, 0)
			elseif mo.mariofirehit == fires*2/4
				GetNice(mo, 1)
			elseif mo.mariofirehit == fires*3/4
				GetNice(mo, 2)
			elseif mo.mariofirehit == fires
				GetNice(mo, 3)
			end
		end
	end
	
	//Iterate through our fireballs, make sure they do damage
	for id,fireball in pairs(mo.mariofireballs) do
		if fireball and fireball.valid and fireball.fuse == 1
			P_KillMobj(fireball)
			fireball.fuse = 0
			
			//Change our target to the fireball's
			target = fireball.hnext
			
			if target and target.valid and target.hp
				if type(btl.dmg_hits[target.dmg_index][1]) == "number"
					btl.dmg_hits[target.dmg_index][1] = $/(fires*FIREBUFFMUL/FIREBUFFDIV)
				end
				damageObject(target)
				
				if timer <= STOPTIME
					target.momz = 0
				end
				
				MarioDoHit(target, size, fireball.nice)
				if size
					localquake(mo.battlen, FRACUNIT*5, 5)
				end
				
				//Ice
				if firetype == 2
					playSound(mo.battlen, size and sfx_bufu4 or sfx_bufu2)
					
					for i=1,4
					local bb = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*20, MT_BUFU_PARTICLE)
						bb.state, bb.scale = i%2 and S_BUFU_PARTICLE_B or S_BUFU_PARTICLE_A, mo.scale
						bb.momx, bb.momy, bb.momz = P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(-3, 3)*FRACUNIT, P_RandomRange(7, 14)*FRACUNIT
					end
					
				//Fire
				else
					playSound(mo.battlen, size and sfx_fire2 or sfx_fire1)
					local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
					sm.fuse = TICRATE
				
					for	i = 1, 4
						local smoke = P_SpawnMobj(fireball.x, fireball.y, fireball.z, MT_SMOKE)
						smoke.scale = mo.scale
						smoke.momx = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momy = P_RandomRange(-4, 4)*FRACUNIT
						smoke.momz = P_RandomRange(2, 5)*FRACUNIT
					end
				end
			end
		end
	end
		
	if timer >= STOPTIME + TICRATE
		return true
	end
end

attackDefs["fire orb"] = {
	name = "Fire Orb",
	type = ATK_FIRE,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	hits = ORBFIRES,
	desc = "Throw up to "..ORBFIRES.." weak\nfireballs at one target.\nMash B to shoot!",
	target = TGT_ENEMY,
	
	hudfunc = FireOrbHUD,
	anim = FireOrbAnim,
}

attackDefs["ice orb"] = {
	name = "Ice Orb",
	type = ATK_ICE,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	hits = ORBFIRES,
	desc = "Throw up to "..ORBFIRES.." weak\niceballs at one target.\nMash B to shoot!",
	target = TGT_ENEMY,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 2)
	end,
}

local SUPERFIRES = 16

attackDefs["super flame"] = {
	name = "Super Flame",
	type = ATK_FIRE,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	hits = SUPERFIRES,
	desc = "Throw up to "..SUPERFIRES.." medium\nfireballs at one target.\nMash B to shoot!",
	target = TGT_ENEMY,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 0, FRACUNIT*3/2, SUPERFIRES)
	end,
}

attackDefs["super hail"] = {
	name = "Super Hail",
	type = ATK_ICE,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	hits = SUPERFIRES,
	desc = "Throw up to "..SUPERFIRES.." medium\niceballs at one target.\nMash B to shoot!",
	target = TGT_ENEMY,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 2, FRACUNIT*3/2, SUPERFIRES)
	end,
}

local ULTRAFIRES = 20

attackDefs["ultra flame"] = {
	name = "Ultra Flame",
	type = ATK_FIRE,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 18,
	hits = ULTRAFIRES,
	desc = "Throw up to "..ULTRAFIRES.." strong\nfireballs at all enemies.\nMash B to shoot!",
	target = TGT_ALLENEMIES,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 0, FRACUNIT*2, ULTRAFIRES)
	end,
}

attackDefs["ultra hail"] = {
	name = "Ultra Hail",
	type = ATK_ICE,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 18,
	hits = ULTRAFIRES,
	desc = "Throw up to "..ULTRAFIRES.." strong\niceballs at all enemies.\nMash B to shoot!",
	target = TGT_ALLENEMIES,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 2, FRACUNIT*2, ULTRAFIRES)
	end,
}

local ULTIMATEFIRES = 24

attackDefs["ultimate flame"] = {
	name = "Ultimate Flame",
	type = ATK_FIRE,
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 32,
	hits = ULTIMATEFIRES,
	desc = "Throw up to "..ULTIMATEFIRES.." massive golden\nfireballs at all enemies.\nMash B to shoot!",
	target = TGT_ALLENEMIES,
	
	hudfunc = FireOrbHUD,
	anim = function(mo, targets, hittargets, timer)
		return FireOrbAnim(mo, targets, hittargets, timer, 1, FRACUNIT*2, ULTIMATEFIRES)
	end,
}

//
//Hands
//

local HANDTIMING = TICRATE*3
local HANDWAIT = TICRATE
local HANDSHOCKS = 2
local HANDAMOUNT = 3
local HANDBUTTONS = {
	"up", "down", "left", "right", "a", "b"
}
local STRINGTRANSLATE = {
	["up"] = "",
	["down"] = "",
	["left"] = "",
	["right"] = "",
}

states[freeslot("S_LUIGI_CAST1")] = {SPR_MRPT, 29|FF_TRANS80, 2, nil, 0, 0, freeslot("S_LUIGI_CAST2")}
states[S_LUIGI_CAST2] = {SPR_MRPT, 30|FF_TRANS60, 2, nil, 0, 0, freeslot("S_LUIGI_CAST3")}
states[S_LUIGI_CAST3] = {SPR_MRPT, 31|FF_TRANS40, 2, nil, 0, 0, freeslot("S_LUIGI_CAST4")}
states[S_LUIGI_CAST4] = {SPR_MRPT, 32|FF_TRANS20, 2, nil, 0, 0, freeslot("S_LUIGI_CAST")}
states[S_LUIGI_CAST] = {SPR_MRPT, 29|FF_ANIMATE, 8, nil, 3, 2, S_LUIGI_CAST}

local function ThunderHandHUD(v, mo, timer)
	//Text
	if timer < STARTTIME
		v.drawScaled(160*FRACUNIT, 50*FRACUNIT, FRACUNIT, v.cachePatch("MRBANNER"))
		v.drawString(92, 36, string.sub("Follow the buttons!", 1, timer))
		return
	end
	
	local timing = mo.mariohandtiming or HANDTIMING
	local handtimer = timer + (mo.marioextratimer or 0) - STARTTIME
	local shocktimer = max(handtimer%(timing + HANDWAIT) - HANDWAIT, 0)
	local x = 240
	local y = 100
	
	//Bars
	v.drawScaled(x*FRACUNIT, y*FRACUNIT, FRACUNIT, v.cachePatch("LUBAR"), 0)
	
	x = $ - 68
	v.drawFill(x, y + 13, 136, 6, 237)
	
	if not mo.mariohandbuttons then return end
	v.drawFill(x, y + 14, shocktimer*136/timing, 4, 73)
	
	//Buttons
	y = $ - 4
	x = $ + 16
	for i,button in ipairs(mo.mariohandbuttons) do
		local string = STRINGTRANSLATE[button] or button
		local flags = 0
		if mo.mariohandsuccesses and i <= mo.mariohandsuccesses
			flags = V_YELLOWMAP
		end
		
		if button == "up" or button == "down"
			v.drawString(x, y, "|", flags, "center")
		elseif button == "left"
			v.drawString(x + 2, y, "-", flags, "center")
		elseif button == "right"
			v.drawString(x - 2, y, "-", flags, "center")
		end
		v.drawString(x, y, string, flags, "center")
		x = $ + 128/#mo.mariohandbuttons
	end
end

local function ThunderHandAnim(mo, targets, hittargets, timer, handtype, size, shocks, timing, amount)
	shocks = $ or HANDSHOCKS
	amount = $ or HANDAMOUNT
	size = $ or 0
	mo.mariohandtiming = timing or HANDTIMING
	local STOPTIME = shocks*(mo.mariohandtiming+HANDWAIT) + STARTTIME

	local player = mo.control
	
	//Detect direction input
	if player and mo.mariopressdirection != nil
	and (abs(player.cmd.forwardmove) >= 25 or abs(player.cmd.sidemove) >= 25)
		mo.mariopressdirection = $ + 1
	else
		mo.mariopressdirection = 0
	end
	
	//Intialize
	if timer == 1
		mo.marioactioncommand = false
		mo.marioextratimer = 0
		mo.mariohandhit = 0
		mo.mariohandsuccesses = 0
		mo.mariohandbuttons = {}
		for i = 1, amount
			mo.mariohandbuttons[i] = "_"
		end
		
		ANIM_set(mo, mo.anim_special6, true)
		
		local thok = P_SpawnMobjFromMobj(mo,
		P_ReturnThrustX(nil, mo.angle, -FRACUNIT),
		P_ReturnThrustY(nil, mo.angle, -FRACUNIT),
		player and player.height/2 or FixedDiv(mo.height/2, mo.scale), MT_THOK)
		thok.state = S_LUIGI_CAST1
		thok.fuse = TICRATE
		
		playSound(mo.battlen, sfx_mrcast)
		
	elseif timer == STARTTIME
		ANIM_set(mo, mo.anim_special5, true)
		if handtype
			playSound(mo.battlen, sfx_luwind)
		else
			playSound(mo.battlen, sfx_luthdr)
		end
	end
	
	//Get target
	local btl = server.P_BattleStatus[mo.battlen]
	local target = hittargets[(mo.mariohandhit % #hittargets) + 1]
	mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y, 0,0)
	
	timer = $ + mo.marioextratimer
	local handtimer = timer - STARTTIME
	if handtimer > 0 and timer <= STOPTIME
		local shocktimer = handtimer%(HANDTIMING + HANDWAIT)
		
		//Do inputs
		if shocktimer and timer < STOPTIME
			local currentbutton = mo.mariohandbuttons and mo.mariohandbuttons[mo.mariohandsuccesses + 1]
			shocktimer = $ - HANDWAIT
			
			//Negatives
			if shocktimer < 0
				if shocktimer == -1
					mo.mariohandsuccesses = 0
					mo.mariohandbuttons = {}
					for i = 1, amount
						mo.mariohandbuttons[i] = HANDBUTTONS[P_RandomRange(1, #HANDBUTTONS)]
					end
				end
				return
			
			//Skip to next
			elseif mo.marioactioncommand
				mo.marioextratimer = $ + max(HANDTIMING - shocktimer - 1, 0)
				
			//Invalid?
			elseif currentbutton == nil
				mo.marioactioncommand = true
				
			//Press the button!
			elseif not player or (mo.mariopressdirection == 1
			and ((currentbutton == "up" and player.cmd.forwardmove > 0 and abs(player.cmd.sidemove) < 35)
			or (currentbutton == "down" and player.cmd.forwardmove < 0 and abs(player.cmd.sidemove) < 35)
			or (currentbutton == "left" and player.cmd.sidemove < 0 and abs(player.cmd.forwardmove) < 35)
			or (currentbutton == "right" and player.cmd.sidemove > 0 and abs(player.cmd.forwardmove) < 35)))
			or (player.realmo.P_inputs[BT_JUMP] == 1 and currentbutton == "a")
			or ((player.realmo.P_inputs[BT_SPIN] == 1
			or player.realmo.P_inputs[BT_CUSTOM1] == 1) and currentbutton == "b")
				playSound(mo.battlen, sfx_lucorr)
				mo.mariohandsuccesses = $ + 1
				
				if mo.mariohandsuccesses >= #mo.mariohandbuttons
					mo.marioactioncommand = true
				end
				
			//Failure
			elseif mo.mariopressdirection == 1
			or player.realmo.P_inputs[BT_JUMP] == 1
			or player.realmo.P_inputs[BT_SPIN] == 1
			or player.realmo.P_inputs[BT_CUSTOM1] == 1
				mo.marioactioncommand = true
			end
			
			//Charge sound
			if shocktimer == 1
				S_StartSound(mo, sfx_luchg1)
			elseif shocktimer > 42 and not ((shocktimer - 42) % 6)
				S_StartSound(mo, sfx_luchg2)
			end
			
			//Charge effect
			ANIM_set(mo, mo.anim_special5, true)
			if (shocktimer > 42 and not ((shocktimer - 42) % 6))
			or (shocktimer <= 42 and not (shocktimer % 12))
				local thok = P_SpawnMobjFromMobj(mo,
				P_ReturnThrustX(nil, mo.angle, mo.radius),
				P_ReturnThrustY(nil, mo.angle, mo.radius),
				player and player.height*2/3 or FixedDiv(mo.height*2/3, mo.scale), MT_THOK)
				thok.state = S_CACOFIRE_EXPLODE1
				if handtype
					thok.color = SKINCOLOR_COURTYARD
					thok.colorized = true
				end
			end
			
		//Do shock
		else
			if mo.marioactioncommand and mo.mariohandsuccesses >= #mo.mariohandbuttons
				ANIM_set(mo, mo.anim_getup, true)
				P_SetObjectMomZ(mo, 8*FRACUNIT)
				
				//Damage
				if type(btl.dmg_hits[target.dmg_index][1]) == "number"
					btl.dmg_hits[target.dmg_index][1] = $/(shocks*FIREBUFFMUL/FIREBUFFDIV)
				end
				damageObject(target)
				
				//Effects (Wind)
				if handtype
					playSound(mo.battlen, sfx_luwhsh)
					if size
						playSound(mo.battlen, sfx_wind1)
						MarioDoStars(target)
						if size == 2
							playSound(mo.battlen, sfx_sprxpl)
						end
					end
					
					for i = 1, 3
						local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						s.scale = FRACUNIT/4
						s.sprite = SPR_SLAS
						s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
						s.destscale = FRACUNIT*9
						s.scalespeed = FRACUNIT
					end
					
					local thok = P_SpawnMobjFromMobj(target, 0,0,0, MT_THOK)
					P_SetObjectMomZ(thok, 8*FRACUNIT)
					thok.state = S_INVISIBLE
					thok.flags = $ &~ MF_NOGRAVITY
					thok.tics = TICRATE*2
					thok.hp = 1
					
					for i = 1, (size + 1)*8
						local g = P_SpawnMobj(thok.x, thok.y, thok.z + P_RandomRange(0, 60*(size+1))*FRACUNIT, MT_GARU)
						g.target = thok
						g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
						if i == 1 or i == 8
							g.jizzcolor = true
						end
						if i%2
							g.invertrotation = true
						end
						g.dist = P_RandomRange(45, 90*(size+1))
						g.tics = TICRATE
						g.lowquality = true
					end
					
				//Effects (Thunder)
				else
					playSound(mo.battlen, sfx_lushck)
					if size == 3
						playSound(mo.battlen, sfx_mrblow)
						playSound(mo.battlen, sfx_mrglxp)
						lightningblast(target, SKINCOLOR_SKY, FRACUNIT*3)
						for i = 1, 10
							local range = 1024
							local z1 = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.z, MT_DUMMY)
							z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_SKY
							z1.destscale = target.scale
							z1.tics = $ + P_RandomRange(-1, 12)
						end
					elseif size == 2
						playSound(mo.battlen, sfx_mrblow)
						lightningblast(target, SKINCOLOR_SKY, FRACUNIT*3/2)
					else
						local z1 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
						z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_TEAL
						z1.destscale = target.scale
						local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
						z2.state, z2.scale, z2.color = S_LZIO21, target.scale*9/4, SKINCOLOR_SKY
						z2.destscale = target.scale
						
						if size
							z1.scale = target.scale*15/4
							z2.scale = target.scale*15/4
							z1.destscale = target.scale*3/2
							z2.destscale = target.scale*3/2
							
							for i = 1, 2
								if not (timer%3)
									local angle = P_RandomRange(1, 359)*ANG1
									local dist = P_RandomRange(30, 36)

									local s = P_SpawnMobj(target.x+(dist*cos(angle)), target.y+(dist*sin(angle)), target.floorz, MT_DUMMY)
									s.state, s.color, s.scale = S_SSPK1, SKINCOLOR_WHITE, target.scale*2
									s.momz, s.destscale = P_RandomRange(5, 24)*FRACUNIT, FRACUNIT/6
									P_InstaThrust(s, angle, P_RandomRange(6, 8)*FRACUNIT)
								end
							end
							playSound(mo.battlen, sfx_zio2)
						else
							playSound(mo.battlen, sfx_zio1)
						end
					end
				end
				
				//Hit
				MarioDoHit(target, size, mo.mariohandhit/max(shocks/4, 1))
				if size
					local quakepower = (size+1)*3
					localquake(mo.battlen, FRACUNIT*quakepower, quakepower)
				end
				
				//Get nices
				mo.mariohandhit = $ + 1
				if mo.mariohandhit == shocks/4
					GetNice(mo, 0)
				elseif mo.mariohandhit == shocks*2/4
					GetNice(mo, 1)
				elseif mo.mariohandhit == shocks*3/4
					GetNice(mo, 2)
				elseif mo.mariohandhit == shocks
					GetNice(mo, 3)
				end
				
			//Failure
			else
				ANIM_set(mo, mo.anim_special3, true)
				playSound(mo.battlen, sfx_luwrng)
				playSound(mo.battlen, sfx_mrhit)
				MarioDoHit(mo, false, 0)
				if leveltime & 1
					playSound(mo.battlen, sfx_luoua)
				else
					playSound(mo.battlen, sfx_lupois)
				end
			end
			
			S_StopSoundByID(mo, sfx_luchg1)
			S_StopSoundByID(mo, sfx_luchg2)
			
			//Reset for next shock
			mo.marioactioncommand = false
		end
	end
		
	if timer >= STOPTIME + TICRATE
		return true
	end
end

attackDefs["thunder hand"] = {
	name = "Thunder Hand",
	type = ATK_ELEC,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	hits = HANDSHOCKS,
	desc = "Summon "..HANDSHOCKS.." weak bolts of\nlightning to damage one target.\nPress the buttons as instructed!",
	target = TGT_ENEMY,
	
	hudfunc = ThunderHandHUD,
	anim = ThunderHandAnim,
}

attackDefs["wind hand"] = {
	name = "Wind Hand",
	type = ATK_WIND,
	power = 60,
	accuracy = 95,
	costtype = CST_SP,
	cost = 4,
	hits = HANDSHOCKS,
	desc = "Summon "..HANDSHOCKS.." weak swirling\ntornados to damage one target.\nPress the buttons as instructed!",
	target = TGT_ENEMY,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, true)
	end,
}

local SUPERHANDSHOCKS = 3
local SUPERHANDAMOUNT = 4

attackDefs["super thunder"] = {
	name = "Super Thunder",
	type = ATK_ELEC,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	hits = SUPERHANDSHOCKS,
	desc = "Summon "..SUPERHANDSHOCKS.." medium bolts of\nlightning to damage one target.\nPress the buttons as instructed!",
	target = TGT_ENEMY,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, false, 1, SUPERHANDSHOCKS, nil, SUPERHANDAMOUNT)
	end,
}

attackDefs["super wind"] = {
	name = "Super Wind",
	type = ATK_WIND,
	power = 140,
	accuracy = 95,
	costtype = CST_SP,
	cost = 8,
	hits = SUPERHANDSHOCKS,
	desc = "Summon "..SUPERHANDSHOCKS.." medium swirling\ntornados to damage one target.\nPress the buttons as instructed!",
	target = TGT_ENEMY,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, true, 1, SUPERHANDSHOCKS, nil, SUPERHANDAMOUNT)
	end,
}

local ULTRAHANDSHOCKS = 4
local ULTRAHANDAMOUNT = 5

attackDefs["ultra thunder"] = {
	name = "Ultra Thunder",
	type = ATK_ELEC,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 18,
	hits = ULTRAHANDSHOCKS,
	desc = "Summon "..ULTRAHANDSHOCKS.." strong bolts of\nlightning to damage all enemies.\nPress the buttons as instructed!",
	target = TGT_ALLENEMIES,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, false, 2, ULTRAHANDSHOCKS, nil, ULTRAHANDAMOUNT)
	end,
}

attackDefs["ultra wind"] = {
	name = "Ultra Wind",
	type = ATK_WIND,
	power = 350,
	accuracy = 95,
	costtype = CST_SP,
	cost = 18,
	hits = ULTRAHANDSHOCKS,
	desc = "Summon "..ULTRAHANDSHOCKS.." strong swirling\ntornados to damage all enemies.\nPress the buttons as instructed!",
	target = TGT_ALLENEMIES,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, true, 2, ULTRAHANDSHOCKS, nil, ULTRAHANDAMOUNT)
	end,
}

local ULTIMATEHANDSHOCKS = 5
local ULTIMATEHANDAMOUNT = 6

attackDefs["ultimate thunder"] = {
	name = "Ultimate Thunder",
	type = ATK_ELEC,
	power = 650,
	accuracy = 95,
	costtype = CST_SP,
	cost = 32,
	hits = ULTIMATEHANDSHOCKS,
	desc = "Summon "..ULTIMATEHANDSHOCKS.." massive bolts of\nlightning to damage all enemies.\nPress the buttons as instructed!",
	target = TGT_ALLENEMIES,
	
	hudfunc = ThunderHandHUD,
	anim = function(mo, targets, hittargets, timer)			//handtype, size, shocks, timing, amount)
		return ThunderHandAnim(mo, targets, hittargets, timer, false, 3, ULTIMATEHANDSHOCKS, nil, ULTIMATEHANDAMOUNT)
	end,
}