//
//The Lua for Mario's Overalls
//

local FRAMEFLAGS = FF_FRAMEMASK|FF_TRANSMASK|FF_FULLBRIGHT|FF_VERTICALFLIP|FF_HORIZONTALFLIP|FF_PAPERSPRITE

//Secondcolor stuff
local overallscolors = {
	//Custom Colors
	[SKINCOLOR_TOADSTOOL] = SKINCOLOR_BLUEFLOWER,
	[SKINCOLOR_BLUEFLOWER] = SKINCOLOR_TOADSTOOL,
	[SKINCOLOR_MUSHROOM] = SKINCOLOR_SAPPHIRE,
	[SKINCOLOR_SHELL] = SKINCOLOR_SANDY,
	[SKINCOLOR_UNDERGROUND] = SKINCOLOR_MUSHROOM,
	[SKINCOLOR_MONDO] = SKINCOLOR_TUBULAR,
	[SKINCOLOR_TUBULAR] = SKINCOLOR_ROSY,
	[SKINCOLOR_GROOVY] = SKINCOLOR_MONDO,
	[SKINCOLOR_FUNKY] = SKINCOLOR_MONDO,
	[SKINCOLOR_LETHAL] = SKINCOLOR_DIRE,
	[SKINCOLOR_DIRE] = SKINCOLOR_LETHAL,
	[SKINCOLOR_COURTYARD] = SKINCOLOR_LETHAL,
	
	//Reds
	[SKINCOLOR_SALMON] = SKINCOLOR_BLUEBELL,
	[SKINCOLOR_RED] = -1,
	[SKINCOLOR_CRIMSON] = SKINCOLOR_COBALT,
	[SKINCOLOR_PINK] = SKINCOLOR_RED,
	[SKINCOLOR_ROSY] = SKINCOLOR_EMERALD,
	
	//Oranges
	[SKINCOLOR_KETCHUP] = SKINCOLOR_ICY,
	[SKINCOLOR_ORANGE] = SKINCOLOR_AQUA,
	[SKINCOLOR_RUST] = SKINCOLOR_RED,
	
	//Blues
	[SKINCOLOR_SAPPHIRE] = SKINCOLOR_AETHER,
	[SKINCOLOR_CORNFLOWER] = SKINCOLOR_SALMON,
	[SKINCOLOR_BLUE] = SKINCOLOR_RED,
	[SKINCOLOR_COBALT] = SKINCOLOR_CRIMSON,
	
	//Pale Blues
	[SKINCOLOR_AETHER] = SKINCOLOR_CORNFLOWER,
	[SKINCOLOR_SLATE] = SKINCOLOR_CORNFLOWER,
	[SKINCOLOR_AZURE] = SKINCOLOR_SALMON,
	[SKINCOLOR_BLUEBELL] = SKINCOLOR_RED,
	[SKINCOLOR_DUSK] = SKINCOLOR_CRIMSON,
	
	//Cyans
	[SKINCOLOR_SKY] = SKINCOLOR_ROSY,
	[SKINCOLOR_CYAN] = SKINCOLOR_UNDERGROUND,
	[SKINCOLOR_ICY] = SKINCOLOR_GOLD,
	
	//Greens
	[SKINCOLOR_GREEN] = SKINCOLOR_BROWN,
	[SKINCOLOR_FOREST] = SKINCOLOR_BRONZE,
	[SKINCOLOR_EMERALD] = SKINCOLOR_SANDY,
	
	//Other
	[SKINCOLOR_GOLD] = SKINCOLOR_WHITE,
	[SKINCOLOR_YELLOW] = SKINCOLOR_PURPLE,
	[SKINCOLOR_PURPLE] = SKINCOLOR_RED,
	[SKINCOLOR_LAVENDER] = SKINCOLOR_UNDERGROUND,
	
	//Greyscale
	[SKINCOLOR_WHITE] = SKINCOLOR_YELLOW,
	[SKINCOLOR_GREY] = SKINCOLOR_PURPLE,
	[SKINCOLOR_SILVER] = SKINCOLOR_PURPLE,
	[SKINCOLOR_BLACK] = SKINCOLOR_RED,
}

//Colors for Luigi
local luigicolors = {
	//Custom Colors
	[SKINCOLOR_TOADSTOOL] = SKINCOLOR_QUAIL,
	[SKINCOLOR_BLUEFLOWER] = SKINCOLOR_SHELL,
	[SKINCOLOR_MUSHROOM] = SKINCOLOR_MONDO,
	[SKINCOLOR_SHELL] = SKINCOLOR_UNDERGROUND,
	[SKINCOLOR_UNDERGROUND] = SKINCOLOR_SHELL,
	[SKINCOLOR_MONDO] = SKINCOLOR_GROOVY,
	[SKINCOLOR_GROOVY] = SKINCOLOR_FUNKY,
	[SKINCOLOR_FUNKY] = SKINCOLOR_GROOVY,
	[SKINCOLOR_LETHAL] = SKINCOLOR_COURTYARD,
	[SKINCOLOR_DIRE] = SKINCOLOR_COURTYARD,
	[SKINCOLOR_COURTYARD] = SKINCOLOR_DIRE,
	
	//Reds
	[SKINCOLOR_SALMON] = SKINCOLOR_BROWN,
	[SKINCOLOR_RED] = SKINCOLOR_SANDY,
	[SKINCOLOR_CRIMSON] = SKINCOLOR_BRONZE,
	
	//Blues
	[SKINCOLOR_CORNFLOWER] = SKINCOLOR_GREEN,
	[SKINCOLOR_BLUE] = SKINCOLOR_EMERALD,
	[SKINCOLOR_COBALT] = SKINCOLOR_FOREST,
	
	//Pale Blues
	[SKINCOLOR_AZURE] = SKINCOLOR_GREEN,
	[SKINCOLOR_BLUEBELL] = SKINCOLOR_EMERALD,
	[SKINCOLOR_DUSK] = SKINCOLOR_FOREST,
	
	//Greens
	[SKINCOLOR_GREEN] = SKINCOLOR_UNDERGROUND,
	[SKINCOLOR_FOREST] = SKINCOLOR_UNDERGROUND,
	[SKINCOLOR_EMERALD] = SKINCOLOR_PURPLE,
	
	//Other
	[SKINCOLOR_PURPLE] = SKINCOLOR_EMERALD,
	[SKINCOLOR_BLACK] = SKINCOLOR_GREEN,
}

rawset(_G, "GetMarioOverallsColor", function(color, player)
	if color == nil then return -1 end
	
	local opposite = (player and player.mariosecondcolor)
	or (player and skins[player.skin].name == "luigi" and luigicolors[color]
	or overallscolors[color]) or ColorOpposite(color)
	
	if not (player and player.mariosecondcolor)
	and (string.lower(R_GetNameByColor(color)) == "sushi"
	or string.lower(R_GetNameByColor(color)) == "blush")
		if skins[player.skin].name == "luigi"
			opposite = SKINCOLOR_SANDY
		else
			opposite = SKINCOLOR_BLUEBELL
		end
	
	elseif opposite == -1
		opposite = SKINCOLOR_BLUE
	end
	
	return opposite
end)

mobjinfo[freeslot("MT_MARIO_OVERALLS")] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = mobjinfo[MT_PLAYER].radius,
	height = mobjinfo[MT_PLAYER].height,
	dispoffset = 1,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT
}

rawset(_G, "DoMarioOveralls", function(player, mo, overalls)
	local realoveralls = true
	if not (overalls and overalls.valid and overalls.state > S_NULL
	and overalls.type == MT_MARIO_OVERALLS)
		if mo and mo.valid and player.followitem == MT_MARIO_OVERALLS
		and (not mo.health or player.guard)
			overalls = P_SpawnMobjFromMobj(mo, 0,0,0, MT_MARIO_OVERALLS)
			overalls.fuse = 1
			realoveralls = false
		else
			return
		end
	end
	overalls.target = mo
	overalls.tracer = mo
	
	local color = GetMarioOverallsColor(player.skincolor, player)
	if srb2p and mo.control and mo.control.maincontrol != mo
		color = GetMarioOverallsColor(mo.color)
	end
	
	if not (mo and mo.valid)
		overalls.state = overalls.info.spawnstate
		A_CapeChase(overalls,1,0)
		return true
	end
	
	//Why are we in super frames? That's stupid
	if mo.sprite2 & FF_SPR2SUPER
		mo.sprite2 = $ &~ FF_SPR2SUPER
		if mo.state > S_PLAY_SUPER_TRANS1 and mo.state <= S_PLAY_SUPER_TRANS6
			local frame = mo.state - S_PLAY_SUPER_TRANS1 + 1
			mo.frame = ($ &~ FF_FRAMEMASK) | frame
		end
	end
	
	//Set it up
	overalls.skin = mo.skin
	overalls.color = mo.colorized and mo.color or color
	overalls.colorized = mo.colorized
	overalls.scale = mo.scale
	overalls.radius = mo.radius
	overalls.height = mo.height
	overalls.angle = player.drawangle
	
	if skins[overalls.skin].sprites[mo.sprite2|FF_SPR2SUPER].numframes
		if mo.state == S_PLAY_SUPER_TRANS6 or mo.state == S_PLAY_NIGHTS_TRANS5
			overalls.state = S_INVISIBLE
		elseif overalls.state != mo.state
			overalls.state = max(mo.state, S_NULL)
			if not (overalls and overalls.valid) then return end //what if it was S_NULL?
		end
		overalls.tics = mo.tics
		overalls.frame = mo.frame & FRAMEFLAGS
		overalls.sprite2 = mo.sprite2|FF_SPR2SUPER
	else
		overalls.state = S_INVISIBLE
	end
	
	//Super color
	if player.powers[pw_super]
	and mo.state != S_PLAY_SUPER_TRANS1 and mo.state != S_PLAY_SUPER_TRANS2
		overalls.color = SKINCOLOR_WHITE
		overalls.frame = $ | FF_FULLBRIGHT
	end
	
	overalls.rollangle = mo.rollangle
	overalls.mirrored = mo.mirrored
	overalls.spritexscale = mo.spritexscale
	overalls.spriteyscale = mo.spriteyscale
	overalls.spritexoffset = mo.spritexoffset
	overalls.spriteyoffset = mo.spriteyoffset
	overalls.renderflags = mo.renderflags
	overalls.blendmode = mo.blendmode
	overalls.flags2 = mo.flags2 & (MF2_DONTDRAW|MF2_SHADOW|MF2_SPLAT)
	
	if realoveralls
		A_CapeChase(overalls,1,0)
	else
		local health = mo.health
		mo.health = 1
		A_CapeChase(overalls,1,0)
		mo.health = health
	end
	
	//Don't bother with the powerups in persona
	if srb2p or not (overalls and overalls.valid) then return true end
	
	//Can we power up?
	local hadpower = overalls.hadpower or 0
	local hadmario = overalls.hadmario or false
	local shield = -player.powers[pw_invulnerability] or player.powers[pw_shield]
	if not mo.health then shield = 0 end
	
	//Power up flashing
	if not (player.mariopain and player.mariopain.shield)
	or overalls.prevhadpower == nil
		overalls.prevhadpower = hadpower
	else
		hadpower = -1
		if (mo.tics/4) % 2
			shield = player.mariopain.shield
		elseif player.mariopain.powerup
			shield = overalls.prevhadpower
		else
			shield = 0
		end
	end
	overalls.hadpower = shield
	overalls.hadmario = not MARIOSHIELDS[player.powers[pw_shield]]
	
	//Reset for new power ups
	if hadpower != shield or hadmario != overalls.hadmario
		if not player.powers[pw_super]
			mo.color = player.skincolor
			if hadpower < 0
				mo.frame = $ &~ FF_FULLBRIGHT
			end
		end
		mo.colorized = false
		
		if hadpower == shield and hadmario != overalls.hadmario
			SpawnMarioShieldOrb(player)
		end
	end
	
	//Set shield scale
	if MARIOSHIELDS[shield] or shield < 0 or player.mariosize > 0
		player.shieldscale = 0
		overalls.setscale = true
	else
		if overalls.setscale
			overalls.setscale = false
			player.shieldscale = skins[player.skin].shieldscale
		end
		return true
	end
	
	//Star colors
	if shield < 0
		mo.color = SKINCOLOR_RAINBOW
		mo.colorized = true
		overalls.color = SKINCOLOR_RAINBOW
		overalls.colorized = true
		
		//Color shine
		for i = 1, 2
			local spark = P_SpawnMobjFromMobj(overalls, 0,0,0, MT_THOK)
			spark.state = S_NIGHTSPARKLE1
			spark.tics = 7
			
			spark.spritexoffset = P_SignedRandom()*FRACUNIT/6
			spark.spriteyoffset = P_SignedRandom()*FRACUNIT/4 + player.height/2
			if mo.height <= P_GetPlayerSpinHeight(player)
			or (player.pflags & PF_JUMPED and not (player.pflags & PF_NOJUMPDAMAGE))
				spark.spriteyoffset = $*2/3
			end
			
			spark.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
			
			spark.tracer = mo
			spark.color = mo.color
			spark.colorized = true
		end
		
	//Power up colors
	//Fire flower
	elseif shield == SH_FAKEFLOWER or shield == SH_FIREFLOWER
		if mo.color == player.skincolor or mo.color == SKINCOLOR_WHITE
			mo.color = SKINCOLOR_AETHER
		end
		overalls.color = player.skincolor
		
	//Ice flower
	elseif shield == SH_ICEFLOWER
		if mo.color == player.skincolor
			mo.color = SKINCOLOR_SKY
		end
		overalls.color = player.skincolor
		
	//Gold flower
	elseif shield == SH_GOLDFLOWER
		if mo.color == player.skincolor
			mo.color = mo.skin == "luigi" and SKINCOLOR_AETHER or SKINCOLOR_SUPERGOLD5
			mo.colorized = true
		end
		if G_GametypeHasTeams()
			overalls.color = player.skincolor
		else
			overalls.color = mo.skin == "luigi" and SKINCOLOR_AZURE or SKINCOLOR_GOLD
		end
		overalls.colorized = false
		
		//Gold shine
		if not (leveltime % 4) and not player.mariopain
			local spark = P_SpawnMobjFromMobj(overalls, 0,0,0, MT_OVERLAY)
			spark.state = S_NIGHTSPARKLE1
			spark.tics = 7
			
			spark.color = mo.skin == "luigi" and SKINCOLOR_AZURE or SKINCOLOR_GOLD
			spark.colorized = true
			
			spark.spritexoffset = P_SignedRandom()*FRACUNIT/6 + mo.spritexoffset
			spark.spriteyoffset = P_SignedRandom()*FRACUNIT/4 + player.height/2 + mo.spriteyoffset
			if mo.height <= P_GetPlayerSpinHeight(player) or player.marioshoe
			or (player.pflags & PF_JUMPED and not (player.pflags & PF_NOJUMPDAMAGE))
				spark.spriteyoffset = $*2/3
				if player.marioshoe
					spark.spriteyoffset = $ + player.height/2
				end
			end
			
			spark.target = mo
		end
		
	//Metal cap
	elseif shield == SH_METAL
		if mo.color == player.skincolor
			mo.color = SKINCOLOR_GREY
			mo.colorized = true
		end
		if G_GametypeHasTeams()
			overalls.color = player.skincolor
		else
			overalls.color = mo.color
		end
		overalls.colorized = false
		
	//Super Ball
	elseif shield == SH_SUPERBALL
		if mo.color == player.skincolor
			mo.color = SKINCOLOR_MOSS
			mo.colorized = true
		end
		if G_GametypeHasTeams()
			overalls.color = player.skincolor
		else
			overalls.color = SKINCOLOR_MOSSBUTDARK
		end
		overalls.colorized = false
	end

	return true
end)

//Signpost Junk
addHook("MobjThinker", function(mobj)
	if mobj.state != S_SIGNPLAYER then return end
	
	local mo = mobj.target
	local player = mo and mo.valid and IsMario(mo) and mo.player
	if not player then return end
	
	local ov = mobj.tracer and mobj.tracer.valid and mobj.tracer.tracer
	if not ov.valid or ov.skin != mo.skin then return end
	
	local overalls = ov.tracer or P_SpawnMobjFromMobj(ov, 0,0,0, MT_OVERLAY)
	ov.tracer = overalls
	overalls.target = mobj.tracer
	overalls.tracer = mobj.tracer
	
	overalls.skin = mo.skin
	overalls.color = GetMarioOverallsColor(player.skincolor, player)
	
	if skins[mo.skin].sprites[ov.sprite2|FF_SPR2SUPER].numframes
		overalls.state = ov.state
		overalls.tics = -1
		overalls.frame = ov.frame & FRAMEFLAGS
		overalls.sprite2 = ov.sprite2|FF_SPR2SUPER
	end
end, MT_SIGN)