//
//Hey Stinky!
//

local STINKYFRAMES = {
	M, F, G, F, {G, 2}, {H, 2}, {I, 2}, J,
	K, J, I, J, {K, 2}, {L, 2}, {M, 2}, {F, 7},
	{A, 3}, {B, 4}, {C, 3}, {F, 4}, {A, 3}, {B, 4}, {C, 3}, {F, 10},
	{P, 4}, {F, 4}, {P, 4}, {D, 7}, {F, 4}, {P, 4}, {F, 4}, {P, 4},
	{E, 7}, {F, 4}, {P, 4}, {F, 4}, {P, 4}, {O, 7}, {F, 4}, {P, 4},
	{F, 4}, {P, 4}, {N, 7}, {F, 10},
}

sfxinfo[sfx_mrstnk].caption = "Hey, stinky!"
sfxinfo[sfx_mrstnk].singular = true

sfxinfo[sfx_lumalu].caption = "Mama Luigi!"
sfxinfo[sfx_lumalu].singular = true

sfxinfo[sfx_lurdcl].caption = "You look ridiculous."
sfxinfo[sfx_lurdcl].singular = true

if not srb2p
	sfxinfo[sfx_m2stnk].caption = "Hey, stinky!"
	sfxinfo[sfx_m2stnk].singular = true
	sfxinfo[sfx_m3stnk].caption = "Hey, stinky!"
	sfxinfo[sfx_m3stnk].singular = true
	
	sfxinfo[sfx_l2malu].caption = "Mama Luigi!"
	sfxinfo[sfx_l2malu].singular = true
	sfxinfo[sfx_l3malu].caption = "Mama Luigi!"
	sfxinfo[sfx_l3malu].singular = true
	
	sfxinfo[sfx_l2rdcl].caption = "You look ridiculous."
	sfxinfo[sfx_l2rdcl].singular = true
	sfxinfo[sfx_l3rdcl].caption = "You look ridiculous."
	sfxinfo[sfx_l3rdcl].singular = true

	sfxinfo[sfx_lunum1].caption = "Oh yeah! Who's number one now? Luigi!"
	sfxinfo[sfx_lunum1].singular = true
	sfxinfo[sfx_l2num1].caption = "Oh yeah! Who's number one now? Luigi!"
	sfxinfo[sfx_l2num1].singular = true
	sfxinfo[sfx_l3num1].caption = "Oh yeah! Who's number one now? Luigi!"
	sfxinfo[sfx_l3num1].singular = true
end

function A_MarioStinky(mo, var1, var2)
	local player = mo and mo.valid and mo.player
	if not player then return end
	if mo.skin != "mario" then mo.state = S_PLAY_STND return end
	
	player.panim = PA_IDLE
	mo.frame = $ &~ FF_FRAMEMASK
	
	for p in players.iterate
		if p.mo and p.mo.valid and not p.mo.mariostinky
		and not p.mo.stinkymario and R_PointToDist2(0, p.mo.z, R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y), mo.z) < 32*mo.radius
			P_PlayJingleMusic(p, "hystnk", nil, true, JT_OTHER)
			if p != player
				p.mo.stinkymario = mo
				if p == consoleplayer and not var2
					S_SetMusicPosition(MUSICRATE)
				end
			end
		end
	end
	mo.mariostinky = $ or 1
	
	if var2
		mo.frame = $ + F
		return
	end
	
	local frame = STINKYFRAMES[mo.mariostinky]
	if type(frame) == "table"
		mo.tics = frame[2] or $
		frame = $[1]
	end
	if frame == nil
		frame = F
	end
	mo.frame = $ + frame
	
	mo.mariostinky = $ + 1
	if mo.mariostinky > #STINKYFRAMES
		mo.mariostinky = 1
	end
end

states[freeslot("S_MARIO_STINKY1")] = {SPR_PLAY, SPR2_TAL5, TICRATE + 56, A_MarioStinky, 0, 1, freeslot("S_MARIO_STINKY2")}
states[S_MARIO_STINKY2] = {SPR_PLAY, SPR2_TAL5, 5, A_MarioStinky, 0, 0, S_MARIO_STINKY2}

//Music
addHook("ShouldJingleContinue", function(player, musname)
	if string.lower(musname) != "hystnk" return end
	local mo = player.mo
	
	if mo and mo.valid and (mo.mariostinky or (mo.stinkymario and mo.stinkymario.valid
	and mo.stinkymario.mariostinky
	and R_PointToDist2(0, mo.z, R_PointToDist2(mo.x, mo.y, mo.stinkymario.x, mo.stinkymario.y), mo.stinkymario.z) < 32*mo.radius))
		return true
    else
        return false
    end
end)

//Just in case chat messages don't sync
COM_AddCommand("mariofactor", function(player, arg)
	if not (player.mo and player.mo.valid) then return end
	if tonumber(arg) == player.mo.y
	and (skins[player.skin].name == "mario" or skins[player.skin].name == "luigi")
		if not MarioCantMove(player) and player.panim == PA_IDLE
		and not player.speed and P_IsObjectOnGround(player.mo)
		and not player.mo.mariostinky
			if skins[player.skin].name == "mario"
				player.mo.state = S_MARIO_STINKY1
			else
				player.mo.state = S_TAILSOVERLAY_MINUS60DEGREES
				player.panim = PA_IDLE
				player.mo.tics = -1
			end
		end
	else
		CONS_Printf(player, "Factor set!")
	end
end)

//Do the chat message thing
addHook("PlayerMsg", function(player, msgtype, target, msg)
	if not msgtype and msg and (skins[player.skin].name == "mario"
	or skins[player.skin].name == "luigi")
		msg = string.gsub(string.lower($), '[%p%c%s]', '')
		
		if (skins[player.skin].name == "mario" and msg == "heystinky")
		or (skins[player.skin].name == "luigi"
		and (msg == "mamaluigi" or msg == "youlookridiculous"))
			if string.lower(msg) == "youlookridiculous"
				MarioPlayVoice(player, "ridiculous", true)
				return
			end
			MarioPlayVoice(player, "stinky", true)
			
			if player == consoleplayer
			and player.mo and player.mo.valid and not player.mo.momy
				COM_BufInsertText(consoleplayer, "mariofactor "..player.mo.y)
			end
		end
	end
end)