//
//Mario's voice lines and the function to play them
//

function A_MarioVoiceEcho(mo, var1, var2)
	local target = mo.target
	if not target then return end
	if not target.valid or mo.threshold >= mo.reactiontime + TICRATE*2
		mo.state = S_NULL
		return
	end
	
	mo.threshold = $ + 1
	if mo.threshold == mo.reactiontime and mariovoice.value
		S_StartSoundAtVolume(mo, mo.lastlook, mo.cusval)
	end
end
states[freeslot("S_MARIO_VOICEECHO")] = {SPR_NULL, 0, 1, A_MarioVoiceEcho, 0, 0, S_MARIO_VOICEECHO}

//Random function for the voices (local only!)
local mariorandomseed = 3135128580
local MarioRandom = function(a,b)
	mariorandomseed = $*(max(gamemap+globallevelskynum+leveltime, 1)%128)
	if consoleplayer and consoleplayer.valid
	and consoleplayer.mo and consoleplayer.mo.valid
		mariorandomseed = $-(consoleplayer.mo.x+consoleplayer.mo.y+consoleplayer.mo.z)
	end
	mariorandomseed = $/2
	local dumb = ((mariorandomseed*36548569) >> 4) & (FRACUNIT-1)
	return ((dumb * (b-a+1)) >> FRACBITS) + a
end

//Let's freeslot!
local FreeslotVoices = function(...)
	local header = "sfx_mr"
	for i, sound in ipairs({...})
		if i == 1 then header = sound continue end
		
		//Normal voice
		local id = _G[header..sound]
		if id == nil
			id = freeslot(header..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
		
		//We don't need the powerups voices in Persona, they only take up freeslots
		if srb2p then continue end
		
		//Metal voice
		local newheader = string.sub(header, 0, 5) + "2"
		id = _G[newheader..sound]
		if id == nil
			id = freeslot(newheader..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
		
		//Mini voice
		newheader = string.sub(header, 0, 5) + "3"
		id = _G[newheader..sound]
		if id == nil
			id = freeslot(newheader..sound)
		end
		sfxinfo[id].caption = "/"
		sfxinfo[id].flags = SF_TOTALLYSINGLE
	end
end

FreeslotVoices("sfx_mr", "ahah", "ahow", "boig", "die1", "die2", "die3", "doh",
"drwn", "edg1", "edg2", "fall", "grua", "heho", "helo", "hmm", "ho", "hoho",
"hol", "hot", "hray", "huah", "itsa", "lava", "lets", "mama", "muh", "muu", "oh",
"ohho", "okie", "oof", "ow", "pull", "scrm", "shoo", "stnk", "time", "uh", "uhn",
"wah", "waha", "waho", "walf", "wawl", "wehe", "weho", "wihe", "woah", "woch",
"woho", "yah", "yaho", "yehe", "yeho", "yhaw", "yipe", "you", "yul", "supr",
"ohya")

FreeslotVoices("sfx_lu", "aaha", "ahah", "alrg", "die1", "die2", "die3", "drwn",
"edg1", "edg2", "fall", "gowg", "ha", "haya", "heh", "hey", "heya", "ho", "hoah",
"hoho", "hol", "hot", "howa", "hrm", "hu", "huu", "hwah", "igi", "lava", "lets",
"mama", "muh", "num1", "ohya", "ohye", "okie", "oua", "ow", "owho", "owow",
"pull", "read", "scut", "uh", "waah", "wah", "waho", "whoh", "whoo", "woah",
"wow", "wowo", "wrha", "wuho", "yaah", "yah", "yaho", "yahu", "yeho", "yike",
"yuh", "supr", "malu", "rdcl")

//Define the voices...
local MarioVoices = {
	["jump"] = {
		"ho",
		"uhn",
		"wah",
		"wawl",
		"yah",
		"yul",
	},
	
	["double"] = {
		"hol",
		"hoho",
		"muu",
		"muh",
	},
	
	["triple"] = {
		"waha",
		"waho",
		"yaho",
		"yehe",
		"yipe",
	},
	
	["spin"] = {
		"heho",
		"wihe",
		"you",
		"shoo",
		"woho",
		"weho",
	},
	
	["spinjump"] = {
		"ahah",
		"boig",
		"hray",
		"wehe",
		"yhaw",
	},
	
	["dive"] = {
		"hoho",
		"wah",
		"yah",
	},
	
	["hop"] = "walf",
	["recovery"] = {
		"hol",
		"hol",
		"hol",
		"muu",
		"muu",
		"muh",
	},
	
	["long"] = {
		"yaho",
		"yaho",
		"yaho",
		"yaho",
		"yeho",
	},
	
	["groundpound"] = "hmm",
	
	["bonk"] = "doh",
	["butt"] = "oof",
	
	["pain"] = {
		"grua",
		"oh",
		"ohho",
		"ow",
		"huah",
		"woch",
	},
	
	["fall"] = "fall",
	
	["lava"] = {
		"ahow",
		"fall",
		"lava",
		"scrm",
		"hot",
	},
	
	["die"] = {
		"die1",
		"die2",
		"die3",
		"mama",
	},
	
	["drown"] = "drwn",
	
	["edge"] = {
		"edg1",
		"edg2",
	},
	
	["grab"] = "woah",
	["bump"] = "uh",
	["pull"] = "pull",
	
	["hello"] = {
		"helo",
		"itsa",
		"lets",
		"okie",
		"time",
	},
	
	["super"] = "supr",
	["star"] = "ohya",
	
	["stinky"] = "stnk",
	["scuttle"] = "pull",
	["nothing"] = "ohya",
	["ridiculous"] = "stnk",
}

local LuigiVoices = {
	["jump"] = {
		"ha",
		"heh",
		"ho",
		"hu",
		"hwah",
		"yah",
	},
	
	["double"] = {
		"haya",
		"heya",
		"hey",
		"hoah",
		"hol",
		"muh",
	},
	
	["triple"] = {
		"ohya",
		"waho",
		"whoh",
		"whoo",
		"wrha",
		"yahu",
	},
	
	["spin"] = {
		"wuho",
		"yaah",
		"yeho",
		"yuh",
	},
	
	["spinjump"] = {
		"ahah",
		"howa",
		"hoho",
		"waah",
	},
	
	["dive"] = {
		"haya",
		"heya",
		"ho",
		"yah",
	},
	
	["hop"] = "hwah",
	["recovery"] = {
		"hol",
		"hol",
		"hol",
		"hrm",
		"hrm",
		"muh",
	},
	
	["long"] = {
		"yaho",
		"yaho",
		"yaho",
		"yaho",
		"yahu",
	},
	
	["groundpound"] = "huu",
	
	["bonk"] = "uh",
	["butt"] = "oua",
	
	["pain"] = {
		"ow",
		"owho",
		"owow",
		"wah",
		"wow",
		"yike",
	},
	
	["fall"] = "fall",
	
	["lava"] = {
		"aaha",
		"fall",
		"lava",
		"wowo",
		"hot",
	},
	
	["die"] = {
		"die1",
		"die2",
		"die3",
		"mama",
	},
	
	["drown"] = "drwn",
	
	["edge"] = {
		"edg1",
		"edg2",
	},
	
	["grab"] = "woah",
	["bump"] = "uh",
	["pull"] = {
		"pull",
		"ohye",
	},
	
	["hello"] = {
		"gowg",
		"igi",
		"lets",
		"okie",
		"read",
	},
	
	["super"] = "supr",
	["star"] = "alrg",
	
	["stinky"] = "malu",
	["scuttle"] = "scut",
	["nothing"] = "num1",
	["ridiculous"] = "rdcl",
}

//Finally the function that plays it!
rawset(_G, "MarioPlayVoice", function(player, voice, forcenil)
	//Your mouth is closed!
	if (player.powers[pw_shield] == SH_BALLOON and not player.mariopain)
	or player.powers[pw_shield] == SH_SUPERBALL return end
	
	if player.marioechoes and #player.marioechoes
		for i, echo in pairs(player.marioechoes) do
			if echo and echo.valid and echo.type == MT_OVERLAY
				echo.threshold = max($, TICRATE*2)
			end
		end
	end
	player.marioechoes = {}
	
	local mo = player.followmobj
	if mo and mo.valid
		S_StopSound(mo)
	elseif not forcenil
		mo = player.mo
		if not (mo and mo.valid) then return end
	end
	if forcenil then mo = nil end
	
	local luigi = skins[player.skin].name == "luigi"
	local table = luigi and LuigiVoices[voice] or MarioVoices[voice]
	local sound
	if type(table) == "string"
		sound = table
	
	elseif type(table) == "table"
		sound = table[MarioRandom(1, #table)]
		
	else
		sound = voice
	end
	
	//Metal, mini, or normal voice?
	if luigi
		if player.powers[pw_shield] == SH_GOLDFLOWER
		or player.powers[pw_shield] == SH_METAL
			sound = _G["sfx_l2"..$]
		elseif player.mariosize < 0
			sound = _G["sfx_l3"..$]
		else
			sound = _G["sfx_lu"..$]
		end
	elseif player.powers[pw_shield] == SH_GOLDFLOWER
	or player.powers[pw_shield] == SH_METAL
		sound = _G["sfx_m2"..$]
	elseif player.mariosize < 0
		sound = _G["sfx_m3"..$]
	else
		sound = _G["sfx_mr"..$]
	end
	if sound == nil then return end
	
	//Only actually play the sound when enabled via command
	if mariovoice.value
		S_StartSound(mo, sound)
	end
	
	//Set up the Ecco the Dolphin objects
	//We can't have this be local only...
	if not forcenil and mo and player.powers[pw_invulnerability]
		for i = 1, 2
			local echo = P_SpawnMobjFromMobj(mo, 0,0,0, MT_OVERLAY)
			echo.target = mo
			echo.tracer = mo
			echo.cusval = 256 - 96*i
			echo.reactiontime = TICRATE/3*i
			echo.lastlook = sound
			echo.state = S_MARIO_VOICEECHO
			
			player.marioechoes[i] = echo
		end
	end
end)